WoWRCP ={
	cpVersion = "2.3.0",
	db = {},
	Guild_name,
	Server,
	};

local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
local f = CreateFrame('GameTooltip', 'MyTooltip', UIParent, 'GameTooltipTemplate'); -- we load our own tooltip frame
--local frame = LibStub("AceAddon-3.0"):NewAddon("frame", "AceConsole-3.0")
--local acr = LibStub("AceConfigRegistry-3.0")
local state = {};
local acd = LibStub("AceConfigDialog-3.0")
local ac = LibStub("AceConfig-3.0")

local UnitPower={"Rage","Focus","Energy","Happiness","Runes","RunicPower"};UnitPower[0]="Mana";
local UnitSlots={"Head","Neck","Shoulder","Shirt","Chest","Waist","Legs","Feet","Wrist","Hands","Finger0","Finger1","Trinket0","Trinket1","Back","MainHand","SecondaryHand","MainHand","Tabard"};
local UnitStatName={"Strength","Agility","Stamina","Intellect","Spirit"};
local UnitSchoolName={"Physical","Holy","Fire","Nature","Frost","Shadow","Arcane"};
local UnitResistanceName={"Holy","Fire","Nature","Frost","Shadow","Arcane"};

if(not frame.colorTitle) then frame.colorTitle="909090"; end
if(not frame.colorGreen) then frame.colorGreen="00cc00"; end
if(not frame.colorRed)   then frame.colorRed  ="ff0000"; end

local LDBIcon = LibStub("LibDBIcon-1.0", true)
local wowrpref;
local dwowrpref={
		["enabled"]=true,
		["verbose"]=false,
		["reagentfull"]=true,
		["talentsfull"]=true,
		["questsfull"]=false,
		["debug"]=false,
		["ver"]=031000,
		["scan"]={
			["inventory"]=true,
			["currency"]=true,
			["talents"]=true,
			["honor"]=true,
			["reputation"]=true,
			["spells"]=true,
			["pet"]=true,
			["companions"]=true,
			["equipment"]=true,
			["mail"]=true,
			["professions"]=true,
			["quests"]=true,
			["bank"]=true,
			["glyphs"]=true,
			["dstalents"] = true,
			["dsglyphs"] = true,
			["dsspells"] = true,
		},
		["guild"]={
			["compact"]=true,
			["title"]=true,
			["vault"]=true,
			["vault_log"]=true,
			["vault_money"]=true,
			["trades"]=true,
		},
};

frame.class = {WARRIOR=1,PALADIN=2,HUNTER=3,ROGUE=4,PRIEST=5,DEATHKNIGHT=6,SHAMAN=7,MAGE=8,WARLOCK=9,MONK=10,DRUID=11};
frame.race = {Human=1,Orc=2,Dwarf=3,NightElf=4,Scourge=5,Tauren=6,Gnome=7,Troll=8,BloodElf=10,Draenei=11,Worgen=22,Pandaren=24,Pandaren=25, Pandaren=26};
frame.tooltip = "wowrcptooltip";

function frame:Scan(name,func)

	if (func == "on") then
		wowrpref["scan"][name] = true;
		frame:Print(" "..name.." turned on");
	else
		wowrpref["scan"][name] = false;
		frame:Print(" "..name.." turned off");
	end
end

function frame:Options(name,func)

	if (func == "on") then
		wowrpref[name] = true;
		frame:Print(" "..name.." turned on");
	else
		wowrpref[name] = false;
		frame:Print(" "..name.." turned off");
	end
end
--[UnitClass] arg1:unit
frame.UnitSex = function(arg1)
	local UnitSexLabel={UNKNOWN,MALE,FEMALE};
	local unitSexID=UnitSex(arg1);
	return UnitSexLabel[unitSexID],mod(unitSexID,2);
end

--[UnitClass] arg1:unit
frame.UnitClass = function(arg1)
	local unitClass,unitClassEn=UnitClass(arg1);
	return unitClass,unitClassEn,frame.class[unitClassEn];
end

--[UnitClassID] arg1:unit
frame.UnitClassID = function(classEn)
	return frame.class[classEn];
end

--[UnitRace] arg1:unit
frame.UnitRace = function(arg1)
	local unitRace,unitRaceEn=UnitRace(arg1);
	return unitRace,unitRaceEn,frame.race[unitRaceEn];
end

local xstat = {
	_loaded=nil,
	_loadedg=nil,
	_lock=nil,_bag=nil,_bank=nil,_mail=nil,
	_server=GetRealmName(),_player=UnitName("player"),_class=class,
	_skills={},
	_guild=GetGuildInfo("player"),
	_officer=CanViewOfficerNote(),
	_guilded=IsInGuild(),
	_guildInfo=nil,
	_time,
	_guildNum,
	Vault={},
	Vaultavl=true,
	Equipment=0,
	Guild=nil, GuildNum=nil,
	Skills=0, Glyphs=0,
	Talents={},DSTalents={},TalentPts=0,
	Reputation=0,
	Quests=0, QuestsLog=0,
	Mail=nil,
	Honor=nil,
	Bag={},Inventory={},Bank={},
	Professions={}, SpellBook={},
	Pets={}, Stable={}, PetSpell={}, PetTalent={},
	Companions={},
	Achi={},
};

function frame:GButtonHandler()
	self.buttons = {}
	local button = CreateFrame("Button", "GuildProfilerbtm", GuildFrame, "UIPanelButtonTemplate");
	button.tooltip = "Save guild data"--L["Click to export your Guild Profile!"]
	button.startTooltip = button.tooltip
	button:SetPoint("TOPRIGHT", GuildFrame, "TOPRIGHT", -25, 0)
	button:SetWidth(50)
	button:SetHeight(18)
	button:SetText("Save") --L["save"])
	button:SetScript("OnEnter", showTooltip)
	button:SetScript("OnLeave", hideTooltip)
	button:SetScript("OnClick", function(self)frame:gpexport()end )
	self.buttons.save = button
end

function frame:CButtonHandler()
	self.buttons = {}
	local button = CreateFrame("Button", "CharacterProfilerbtm", PaperDollFrame, "UIPanelButtonTemplate");
	button.tooltip = "Save Character data"--L["Click to export your Guild Profile!"]
	button.startTooltip = button.tooltip
	button:SetPoint("TOPRIGHT", PaperDollFrame, "TOPRIGHT", -25, 0)
	button:SetWidth(50)
	button:SetHeight(18)
	button:SetText("Save") --L["save"])
	button:SetScript("OnEnter", showTooltip)
	button:SetScript("OnLeave", hideTooltip)
	button:SetScript("OnClick", function(self)frame:cpexport()end )
	self.buttons.save = button
end

local function findPanel(name, parent)
	for i, button in next, InterfaceOptionsFrameAddOns.buttons do
		if button.element then
			if name and button.element.name == name then return button
			elseif parent and button.element.parent == parent then return button
			end
		end
	end
end
frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
frame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
frame:RegisterEvent("PLAYER_LOGIN");
frame:RegisterEvent("PLAYER_LEAVING_WORLD");
frame:RegisterEvent("BANKFRAME_OPENED");
frame:RegisterEvent("TRADE_SKILL_SHOW");
frame:RegisterEvent("Blizzard_GuildUI");
frame:RegisterEvent("GUILDBANKFRAME_OPENED");
frame:RegisterEvent("GUILD_ROSTER_UPDATE");

function frame:OnEvent(event, arg1)

	if event == "ADDON_LOADED" and arg1 == "wowrcp" then
	
		frame:Print('WoWR Profiler '.. WoWRCP.cpVersion..' Loaded');
	
		if cppref == nil then
			wowrpref = dwowrpref;
		end
		if cppref then
			wowrpref = cppref;
		end
	
		if cpProfile == nil then
			WoWRCP.db = {}
			frame:InitState();
			frame:InitProfile();
			frame:Print("Welcome, " .. UnitName("player") .. " preparing your WoWR Profiler profile!");
			frame:makeconfig();
			frame:CButtonHandler();
			--frame:GPInitProfile()

		end
		if cpProfile then
			WoWRCP.db = cpProfile;
			frame:InitState();
			frame:InitProfile();
			if (cpProfile[xstat["_server"]]["Character"][xstat["_player"]]) then
				frame:Print("Hello again, " .. UnitName("player") .. " Pre-scanning of your profile has started!");
			else
				frame:Print("Hello, " .. UnitName("player") .. " Pre-scanning of your profile has started!");
			end
			frame:makeconfig();
			frame:CButtonHandler();
			--frame:GPInitProfile()
		end
	elseif event == "GUILD_ROSTER_UPDATE" then
	
		if IsInGuild() then
			local test = GetGuildInfo("player")
			if (test ~= nil) then
			
				if (not xstat["_loadedg"]) then
					frame:GPInitProfile();
				end
				
			end
		end
		
	elseif event == "BANKFRAME_OPENED" then
		frame:GetBank();
	elseif arg1 == "Blizzard_GuildUI" then
		frame:GButtonHandler();
	elseif event == "GUILDBANKFRAME_OPENED" then
		frame:GUILDBANKFRAME_OPENED();
	elseif event == "TRADE_SKILL_SHOW" then
		frame:TRADE_SKILL_SHOW();
	elseif event == "PLAYER_LEAVING_WORLD" then
		cpProfile = WoWRCP.db;
		cppref = wowrpref;
	elseif event == "PLAYER_LOGOUT" then
		
		cpProfile = WoWRCP.db;
		cppref = wowrpref;
	end
end


function frame:UpdateDate()
	struct=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"];
	local timestamp = time();
	local currHour,currMinute=GetGameTime();
	if ( not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"] ) then 
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]={};
	end
	
	struct["init"]={};
	struct["init"]["TimeStamp"]=timestamp;
	struct["init"]["Date"]=date("%Y-%m-%d %H:%M:%S",timestamp);
	struct["init"]["DateUTC"]=date("!%Y-%m-%d %H:%M:%S",timestamp);
	struct["init"]["ServerTime"]=format("%02d:%02d",currHour,currMinute);
	struct["init"]["datakey"]=frame.versionkey();
	struct["SpellBook"]={};

	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"] = struct;

end

function frame:InitProfile()
	
	if( not WoWRCP.db[xstat["_server"]] ) then
		WoWRCP.db[xstat["_server"]]={}; 
	end
	if( not WoWRCP.db[xstat["_server"]]["Character"] ) then
		WoWRCP.db[xstat["_server"]]["Character"]={};
	end
	
	if( not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]] ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]={};
		frame:Print('Profile for '.. xstat["_player"] ..' Created');
	else
		frame:Print('Profile for '.. xstat["_player"] ..' Loaded');
	end
	
	local strctx = WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]];
	if( WoWRCP.db ) then

		strctx["CPversion"]		= "2.1.0";
		strctx["CPprovider"]	= "wowr";
		strctx["DBversion"]		= "5.0.3";
		strctx["Name"]			= xstat["_player"];
		strctx["Server"]		= xstat["_server"];
		strctx["Locale"]		= GetLocale();
		strctx["TimePlayed"]	= RequestTimePlayed();
		strctx["Race"],strctx["RaceEn"],strctx["RaceId"]=UnitRace("player")
		strctx["Class"],strctx["ClassEn"],strctx["ClassId"]=frame.UnitClass("player");
		strctx["Sex"],strctx["SexId"]=frame.UnitSex("player");
		strctx["FactionEn"],strctx["Faction"]=UnitFactionGroup("player");
		strctx["HasRelicSlot"]	= UnitHasRelicSlot("player")==1 or false;
		strctx["timestamp"] = {};
		strctx["Cached"] = {};
		xstat["_loaded"] = true;
	end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]] = strctx;
	frame:UpdateDate()
end

function frame:GPInitProfile()
	
	if( not WoWRCP.db[xstat["_server"]]["Guild"] ) then
		WoWRCP.db[xstat["_server"]]["Guild"]={};
	end
	if (not xstat["_guild"]) then
			xstat["_guild"] = GetGuildInfo("player");
	end
	WoWRCP.Guild_name = GetGuildInfo("player");
	if( not WoWRCP.db[xstat["_server"]]["Guild"][WoWRCP.Guild_name] ) then
		WoWRCP.db[xstat["_server"]]["Guild"][WoWRCP.Guild_name]={}; 
		frame:Print('Guild Profile for <'.. WoWRCP.Guild_name ..'> Created');
	else
		if (not xstat["_loadedg"] ) then
		frame:Print('Guild Profile for <'.. WoWRCP.Guild_name ..'> Loaded');
		end
	end
	
	local strcty = WoWRCP.db[xstat["_server"]]["Guild"][WoWRCP.Guild_name];
	local currentXP, remainingXP = UnitGetGuildXP("player");
	local nextLevelXP = currentXP + remainingXP;
		strcty["GPversion"]		= "2.1.0";
		strcty["CPprovider"]	= "wowr";
		strcty["DBversion"]		= "5.0.3";
		strcty["GuildName"]		= WoWRCP.Guild_name;
		strcty["Server"]		= xstat["_server"];
		strcty["Locale"]		= GetLocale();
		strcty["GuildXP"]		= currentXP..":"..nextLevelXP;
		strcty["GuildLevel"]	= GetGuildLevel();
		strcty["FactionEn"],
		strcty["Faction"]		=UnitFactionGroup("player");
		strcty["timestamp"] 	= {};
		strcty["Motd"] 			= GetGuildRosterMOTD();
		xstat["_loadedg"] = true;
		WoWRCP.db[xstat["_server"]]["Guild"][WoWRCP.Guild_name] = strcty;
		frame:GPUpdateDate();
	return xstat["_loadedg"];
end


function frame:makeconfig()
	local acOptions = {
		type = "group",
		name = "WoWRoster Profiler",
		get = GetProperty, set = SetProperty, handler = wowroster,
		args = {
			heading = {
				type = "description",
				name = "Welcome to the WoWRoster Profiler configuration",
				fontSize = "medium",
				order = 9,
				width = "full",
			},

			Scan ={
				type = "group",
				name = "Scan Options",
				args = {
					heading = {
						type = "description",
						name = "Scan Options",
						fontSize = "medium",
						order = 13,
						width = "full",
					},
					heading_info = {
						type = "description",
						name = "Choose what WoWRoster Profiler will scan on your character",
						fontSize = "medium",
						order = 14,
						width = "full",
					},
					inventory = {
						type = "toggle",
						name = "Inventory",
						desc = "Scan the contents of your bags",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 15,
					},
					bank = {
						type = "toggle",
						name = "Bank",
						desc = "Scan the contents of your bank",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 16,
					},
					quests = {
						type = "toggle",
						name = "Quests",
						desc = "Scan your quest log",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 17,
					},
					questsfull= {
						type = "toggle",
						name = "Full Quests",
						desc = "Scan full quest description and objective list",
						set = function(info,val) wowrpref[info[#info]] = val end,
						get = function(info) return wowrpref[info[#info]] end,
						order = 18,
					},
					mail = {
						type = "toggle",
						name = "Mail Box",
						desc = "Scan your mail box",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 19,
					},
					talents = {
						type = "toggle",
						name = "Talents",
						desc = "Scan your talents",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 20,
					},
					glyphs = {
						type = "toggle",
						name = "Glyphs",
						desc = "Scan your glyphs",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 21,
					},
					pet = {
						type = "toggle",
						name = "Pets",
						desc = "Scan Pets [NYI] (returns no data)",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 22,
					},
					spells = {
						type = "toggle",
						name = "Spell Book",
						desc = "Scan your spell book",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 23,
					},
					professions = {
						type = "toggle",
						name = "Professions",
						desc = "Scan Professions",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 24,
					},
					companions = {
						type = "toggle",
						name = "Companions/Mounts",
						desc ="Scan companion and mount data",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 25,
					},
					honor = {
						type = "toggle",
						name = "Honor",
						desc = "Scan honor data",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 26,
					},
					reputation = {
						type = "toggle",
						name = "Reputation",
						desc="Scan reputation data",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 27,
					},
				},
			},

			DSScan ={
				type = "group",
				name = "Dual Spec Options",
				args = {
					heading = {
						type = "description",
						name = "Dual Spec Options",
						fontSize = "medium",
						order = 28,
						width = "full",
					},
					heading_info = {
						type = "description",
						name = "Enable or disable scanning options for your secondary talent spec",
						fontSize = "medium",
						order = 29,
						width = "full",
					},
					dstalents = {
						type = "toggle",
						name = "Talents",
						desc = "Scan your secondary talents",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 30,
					},
					dsglyphs = {
						type = "toggle",
						name = "Glyphs",
						desc = "Scan your secondary glyphs",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 31,
					},
					dsspells = {
						type = "toggle",
						name = "Spell Book",
						desc = "Scan your secondary spell book",
						set = function(info,val) wowrpref["scan"][info[#info]] = val end,
						get = function(info) return wowrpref["scan"][info[#info]] end,
						order = 32,
					},
				},
			},

			guildss ={
				type = "group",
				name = "Guild Scan Options",
				args = {
					heading = {
						type = "description",
						name = "Guild Scan Options",
						fontSize = "medium",
						order = 28,
						width = "full",
					},
					heading_info = {
						type = "description",
						name = "Choose what WoWRoster Profiler will scan for your guild",
						fontSize = "medium",
						order = 29,
						width = "full",
					},
					title = {
						type = "toggle",
						name = "Ranks",
						desc = "Scan member rank data",
						set = function(info,val) wowrpref["guild"][info[#info]] = val end,
						get = function(info) return wowrpref["guild"][info[#info]] end,
						order = 30,
					},
					compact = {
						type = "toggle",
						name = "Compact",
						desc = "Allow empty variables to be skipped",
						set = function(info,val) wowrpref["guild"][info[#info]] = val end,
						get = function(info) return wowrpref["guild"][info[#info]] end,
						order = 31,
					},
					vault = {
						type = "toggle",
						name = "Guild Vault",
						desc = "Scan the guild vault",
						set = function(info,val) wowrpref["guild"][info[#info]] = val end,
						get = function(info) return wowrpref["guild"][info[#info]] end,
						order = 32,
					},
					vault_log = {
						type = "toggle",
						name = "Guild Vault Logs",
						desc = "Scan the guild vault item logs",
						set = function(info,val) wowrpref["guild"][info[#info]] = val end,
						get = function(info) return wowrpref["guild"][info[#info]] end,
						order = 33,
					},
					vault_money = {
						type = "toggle",
						name = "Guild Vault Money Log",
						desc = "Scan the guild vault money log",
						set = function(info,val) wowrpref["guild"][info[#info]] = val end,
						get = function(info) return wowrpref["guild"][info[#info]] end,
						order = 34,
					},
					trades = {
						type = "toggle",
						name = "Guild Skills",
						desc = "Scan the professions list for entire guild [NYI] (no recipes stored)",
						set = function(info,val) wowrpref["guild"][info[#info]] = val end,
						get = function(info) return wowrpref["guild"][info[#info]] end,
						order = 35,
					},
				},
			},
		},
	}

	local server = GetRealmName();
	local acPurge = {
		type = "group",
		name = "Delete Profile Data",
		get = GetProperty, set = SetProperty, handler = wowroster,

		args = {
			heading = {
				type = "description",
				name = "Welcome to the WoWRoster Profiler data configuration",
				fontSize = "medium",
				order = 10,
				width = "full",
			},

			wipec = {
				order = 100,
				name = "Delete one Character",
				desc = "Select a character to delete",
				type = "select",
				values = function( info )
					local t = { }
					for k in pairs( cpProfile[GetRealmName()].Character ) do
						t[k] = k
					end
					return t
				end,
				get = false, -- no default value
				set = function( info, v )
				wowroster:Print("Code to delete data for cpProfiler[" .. GetRealmName() .. "].Character[" .. v .. "]" )
				end,
			},
			wipeac = {
				order = 100,
				name = "Delete all Characters",
				desc = "Delete all character data",
				type = "select",
				values = function( info )
				local t = { }
					for k in pairs( cpProfile ) do
						if (k ~= "profileKeys") then
							for c in pairs( cpProfile[k].Character ) do
								--wowroster:Print("Char: "..c.." "..k);
								if (c ~= "profileKeys") then
									t[c.."-"..k] = ""..c.." ("..k..")"
								end
							end
						end
					end
					return t
				end,
				get = false, -- no default value
				set = function( info, v )
				wowroster:Print("Code to delete data for cpProfiler[" .. GetRealmName() .. "].Character[" .. v .. "]" )
				end,
			},
			wipes = {
				order = 101,
				name = "Delete Server Data",
				desc = "Select a server to delete",
				type = "select",
				values = function( info )
				local t = { }
					for k in pairs( cpProfile ) do
						if (k ~= "profileKeys") then
							t[k] = k
						end
					end
					return t
				end,
				get = false, -- no default value
				set = function( info, v )
				wowroster:Print("Code to delete data for cpProfiler[" .. v .. "]" )
				end,
			},
			wipeg = {
				order = 102,
				name = "Delete Guild Data",
				desc = "Select a guild to delete",
				type = "select",
				values = function( info )
					local t = { }
					if (cpProfile[GetRealmName()]["Guild"]) then
						for k in pairs( cpProfile[GetRealmName()].Guild ) do
							if (k ~= "profileKeys") then
								t[k] = k
							end
					end
					else
						t=nil;
					end
					return t
				end,
				get = false, -- no default value
				set = function( info, v )
				wowroster:Print("Code to delete data for cpProfiler[" .. v .. "]" )
					if(cpProfile[GetRealmName()] and cpProfile[GetRealmName()]["Guild"] and cpProfile[GetRealmName()]["Guild"][v]) then
						cpProfile[GetRealmName()]["Guild"][v]=nil;
						isPurged=true;
						wowroster:Print("Guild "..v.."@"..GetRealmName().." purged");
					end
				end,
			},
--[[
			wipeall = {
				order = 104,
				name = "Delete All",
				desc = "Wipe all data stored",
				type = "execute",
				confirm = "function",
				values = cpProfile = nil,
				get = false, -- no default value
				set = 
				wowroster:Print( "Code to delete data for cpProfiler[" .. GetRealmName() .. "].Character[all]" ),
			
			},
]]--
		},
	}

--[[
	anchor = {
		order	= 9,
		type	= "select",
		name	= L["Anchor"],
		desc	= L["The corner of the Artifacts list that the frame will grow from."],
		get	= function() return db.artifact.anchor end,
		set	= function(_, value) 
			db.artifact.anchor = value
			Archy:SaveFramePosition(racesFrame)
		end,
		values	= frameAnchorOptions,
	},
]]--

	LibStub('AceConfig-3.0'):RegisterOptionsTable("wowroster cp",acOptions)

	ac:RegisterOptionsTable("WoWRoster CP", acOptions)
	--ac:RegisterOptionsTable("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(wowrpref.profiles))

	local mainOpts = acd:AddToBlizOptions("wowroster cp", "WoWRoster Profiler")

	LibStub("AceConfig-3.0"):RegisterOptionsTable("wowroster profiles", acPurge)
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("wowroster profiles", "Profiles", "WoWRoster Profiler")


	mainOpts:HookScript("OnShow", function()
		--frame:Enable()
		local p = findPanel("wowroster cp")
		if p and p.element.collapsed then OptionsListButtonToggle_OnClick(p.toggle) end
	end)
end

frame:SetScript("OnEvent", frame.OnEvent);
SLASH_WOWRCP1 = "/wr";
function SlashCmdList.WOWRCP(argline)

	local msg = frame.Str2Ary(argline);
	local server = GetRealmName();
	
	if msg[1] == 'test' then
		DEFAULT_CHAT_FRAME:AddMessage('This is a test'..msg[1]..'-');
		frame:ScanPetBattle();
--	else
--		DEFAULT_CHAT_FRAME:AddMessage('WoWR Profiler 0.1 MoP Edition');
--	end
	elseif (msg[1] == 'scan') then
		if not msg[2] then
			frame:Print("Scan options are: inventory,currency,talents,honor,reputation,spells,pet,companions,equipment,mail,professions,quests,bank,glyphs");
			frame:Print("Scan options are changed with simple commands '/wr scan currency on' and are toggled with on/off");
		else
			frame:Scan(msg[2],msg[3]);
		end
	
	elseif (msg[1] == "options") then
	
		if not msg[2] then
			frame:Print("Options are: enabled verbose reagentfull talentsfull questsfull debug");
			frame:Print("Options are changed with simple commands '/wr talentsfull on' and are toggled with on/off");
		else
			frame:Options(msg[2],msg[3]);
		end
			
	elseif (msg[1] == "show") then
	
		frame:Show();
		
	elseif (msg[1] == "purge") then
	
		if ( msg[2] == "all" ) then
		
			WoWRCP.db=nil;
			frame:Print("All Data Purged!");--WoWRCP.db=nil;
			return;
			
		end
		if ( msg[2] == "char" ) then
		
			if(WoWRCP.db[server] and WoWRCP.db[server]["Character"] and WoWRCP.db[server]["Character"][msg[3]]) then
			
				WoWRCP.db[server]["Character"][msg[3]]=nil;
				isPurged=true;
				frame:Print("Player "..msg[3].."@"..server.." purged");
			end
			
			return;
		end
		
		if ( msg[2] == "server" ) then
		
			if(cpPofile[xstat["_server"]] and WoWRCP.db[xstat["_server"]]["Character"]) then
			
				WoWRCP.db[xstat["_server"]]["Character"]=nil;
				isPurged=true;
				frame:Print("Server "..xstat["_server"].." purged");
				
			end
			
			return;
		end
		if ( msg[2] == "guild" ) then
		
			profile=msg[3] or GetGuildInfo("player") or "";
			
			if(myProfile[server] and myProfile[server]["Guild"] and myProfile[server]["Guild"][profile]) then
			
				WoWRCP.db[server]["Guild"][profile]=nil;
				isPurged=true;
				frame:Print("Guild "..profile.."@"..xstat["_server"].." purged");
				
			end
			
			return;
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage('WoWR Profiler 0.1 MoP Edition');
	end
	
end

function frame:ShowCP()
	msg = "Equipment:"..xstat["Equipment"].."/"..table.getn(UnitSlots).." ";	
	frame:Print(msg);
	msg="";

	msg = "Skills:";
	tsort={};
	table.foreach(xstat["Professions"], function (k,v) table.insert(tsort,k) end );
	table.sort(tsort);
	if(table.getn(tsort)==0) then
		msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open each profession to scan";
	else
		for _,item in pairs(tsort) do
			msg=msg .. " " .. item..":"..xstat["Professions"][item]["ct"].." errors("..xstat["Professions"][item]["errors"]..")";
		end
	end
	frame:Print(msg);
	msg="";

	msg = "Spells:";
		tsort={};
		table.foreach(xstat["SpellBook"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your spellbook to scan";
		else
			for _,item in pairs(tsort) do
				msg=msg .. " " .. item..":"..xstat["SpellBook"][item];
			end
		end
	frame:Print(msg);
	msg="";

	msg = "Inventory:";
		tsort={};
		table.foreach(xstat["Inventory"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your bank or 'character info' to scan";
		else
			for _,item in pairs(tsort) do
				msg=msg .. " " .. item.."]"..xstat["Inventory"][item]["inv"].."/"..xstat["Inventory"][item]["slot"];
			end
		end
	frame:Print(msg);
	msg="";

	msg = "Bank:";
		tsort={};
		table.foreach(xstat["Bank"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your bank to scan";
		else
			for _,item in pairs(tsort) do
				msg=msg .. " " .. item.."]"..xstat["Bank"][item]["inv"].."/"..xstat["Bank"][item]["slot"];
			end
		end
	frame:Print(msg);
	msg="";

	msg = "Talents:";
		tsort={};
		table.foreach(xstat["Talents"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your talents to scan";
		else
			for _,item in pairs(tsort) do
				msg=msg .. " " .. item..":"..xstat["Talents"][item];
			end
		end
	frame:Print(msg);
	msg="";

	msg = "Glyphs:";
		tsort={};
		table.foreach(xstat["Glyphs"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your talents to scan";
		else
			for _,item in pairs(tsort) do
				msg=msg .. " " .. item..":"..xstat["Glyphs"][item];
			end
		end
	frame:Print(msg);
	msg="";
	
	if( GetNumCompanions ) then 
		msg = "Companions:";
		tsort={};
		table.foreach(xstat["Companions"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned");
		else
			for _,item in pairs(tsort) do
				msg=msg .. " " .. item..":"..xstat["Companions"][item];
			end
		end
	end

	frame:Print(msg);
	msg="";

end

function frame:cpexport()
	frame:GetReputation();
	frame:ScanCurrency();
	frame:GetEquipment(force);
	frame:GetInventory();
	frame:GetTalents(unit);
	frame:ScanCompanions();
	frame:ScanPetBattle();
	frame:GetQuests(force);
	frame:GetArena();
	frame:GetSpellBook();
	frame:SKILLS();
	frame:ScanPetInfo();
	frame:ShowCP();
end
function frame:gpexport()
	
	if (IsInGuild()) then
		if( not WoWRCP.db[xstat["_server"]]["Guild"] ) then
			WoWRCP.db[xstat["_server"]]["Guild"]={};
		end
		if( not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]] ) then
		
			if (not xstat["_guild"]) then
				xstat["_guild"] = GetGuildInfo("player");
			end
			WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]={}; 
		end
		frame:GPInitProfile();
	end
	
	frame:GPUpdateDate();
	frame:GPScanGuildMembers();
	frame:GPScanGuildControl();
	frame:GPScanGuildEventLog();
	--frame:Scannews();
	--frame:ScanGuildControl();
	--frame:ScanGuildEventLog()
	msg = xstat["_guild"];
	print(msg);
	msg = "Vault:";
	tsort={};
	table.foreach(xstat["Vault"], function(k,v) table.insert(tsort,k) end );
		table.sort(tsort);
		if(table.getn(tsort)==0) then
			msg=msg..frame.StringColorize(frame.colorRed," not scanned")..".  - open your guild vault to scan";
		else
		for _,item in pairs(tsort) do
			msg=msg .. " " .. item.."-"..xstat["Vault"][item]["inv"].."/"..xstat["Vault"][item]["slot"];
		end
	end

	print(msg);
	msg = "Members: "..xstat["_guildNum"].." ";
	print(msg);
end 


function frame:InitState()
	local _,class=UnitClass("player");
	xstat = {
		_loaded=nil,_lock=nil,_bag=nil,_bank=nil,_mail=nil,
		_server=GetRealmName(),_player=UnitName("player"),_class=class,
		_skills={},
		_guild=GetGuildInfo("player"),
		_officer=CanViewOfficerNote(),
		_guilded=IsInGuild(),
		_guildInfo=nil,
		_time,
		_guildNum,
		Vault={},
		Vaultavl=true,
		Equipment=0,
		Guild=nil, GuildNum=nil,
		Skills=0, Glyphs=0,
		Talents=0,TalentPts=0,
		Reputation=0,
		Quests=0, QuestsLog=0,
		Mail=nil,
		Honor=nil,
		Bag={},Inventory={},Bank={},
		Professions={}, SpellBook={}, Achi={},
		Pets={}, Stable={}, PetSpell={}, PetTalent={},
		Companions={},
	};

	WoWRCP.Guild_name = GetGuildInfo("player");
	WoWRCP.Server = GetRealmName();
	self.queue={};

	state = function(self,...)
	if(not wowrpref) then return end
	local state = wowrpref;
	local n=select("#",...);
	local key=select(1,...);
	if(n==2) then
		local val=select(2,...);
		if(not state[key]) then
			if(val=='++' or val=='--') then
				state[key]=0;
			end
		end
		if(val=='++') then
			state[key]=state[key]+1;
		elseif(val=='--') then
			state[key]=state[key]-1;
		else
			state[key]=val;
		end
		return true;
	elseif( state and state[key] ) then
		return state[key];
	end
		return nil;
	end
end

State = function(self,...)
	if(not wowrpref) then return end
	local state = wowrpref;
	local n=select("#",...);
	local key=select(1,...);
	if(n==2) then
		local val=select(2,...);
		if(not state[key]) then
			if(val=='++' or val=='--') then
				state[key]=0;
			end
		end
		if(val=='++') then
			state[key]=state[key]+1;
		elseif(val=='--') then
			state[key]=state[key]-1;
		else
			state[key]=val;
		end
		return true;
	elseif( state and state[key] ) then
		return state[key];
	end
	return nil;
end

--[[
	begin pets
]]--

function frame:ScanPetInit(name)
	if(name) then
		if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"]={};
		end
		if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][name]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][name]={};
		end
		if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Pets"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Pets"]={};
		end
	end
end

function frame:ScanPetStable()
	if(wowrpref["scan"]["pet"] and (frame:State("_class")=="HUNTER" and UnitLevel("player")>9)) then
		local stablePets={};
		for petIndex=0,GetNumStableSlots() do
			local petIcon,petName,petLevel,petType,petLoyalty=GetStablePetInfo(petIndex);
			if(petName and petName~=UNKNOWN) then
				frame:ScanPetInit(petName);
				local structPets=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"];
				structPets[petName]["Slot"]=petIndex;
				structPets[petName]["Icon"]=frame.scanIcon(petIcon);
				structPets[petName]["Name"]=petName;
				structPets[petName]["Level"]=petLevel;
				structPets[petName]["Type"]=petType;
				structPets[petName]["Loyalty"]=petLoyalty;
				stablePets[petName]=petIndex;
				WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Pets"][petName]=time();
			end
			xstat["Stable"][petIndex]=petName;
		end
		for petName,_ in pairs( WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"] ) do
			if( not stablePets[petName] ) then
				WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][petName]=nil;
			end
		end
		for petName,_ in pairs( WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Pets"] ) do
			if( not stablePets[petName] ) then
				WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Pets"][petName]=nil;
			end
		end
		frame:ScanPetInfo();
	elseif(WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"]=nil;
		xstat["Pets"]={};
	end
end

function frame:ScanPetInfo()
	if(wowrpref["scan"]["pet"]) then
		if(HasPetUI()) then
			local petName=UnitName("pet");
			if( petName and petName~=UNKNOWN ) then
				frame:ScanPetInit(petName);
				local structPet=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][petName];
				structPet["Name"]=petName;
				structPet["Type"]=UnitCreatureFamily("pet");
				structPet["Experience"]=strjoin(":", GetPetExperience());
				frame:GetStats(structPet,"pet");
				frame:GetBuffs(structPet,"pet");
				
--WotLK
			if( GetPetTalentPoints and (frame:State("_class")=="HUNTER" and UnitLevel("player")>9) ) then
				--frame:GetTalents("pet");
			end
				frame:GetPetSpellBook();
				xstat["Pets"][petName]=1;
				WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Pets"][petName]=time();
			end
		end
	elseif(WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"]=nil;
		xstat["Pets"]={};
	end
end	

function frame:TRADE_SKILL_SHOW()
	if(IsTradeSkillLinked() or IsTradeSkillGuild()) then
		return nil;
	end

	local skillLineName,skillLineRank,skillLineMaxRank=GetTradeSkillLine();
	local numTradeSkills = GetNumTradeSkills();
	local cnt = 0;
	scan_tradename = skillLineName;

	xstat["Professions"][skillLineName] = {};
	if ( not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Professions"] ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Professions"]={};
	end

	local skills = WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Professions"];
	xstat["Professions"][skillLineName]["ct"] = 0;
	xstat["Professions"][skillLineName]["errors"] = 0;

	if(not skills[skillLineName] ) then
		skills[skillLineName]={};
	end

	idxStart = 1;

	for idx=idxStart,numTradeSkills do
		skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps, indentLevel, showProgressBar, currentRank, maxRank, startingRank = GetTradeSkillInfo(idx);
		if( skillName and skillName~="" ) then
			if( skillType == "header" ) then
				lastHeaderIdx = idx;
				skillHeader=skillName;
				skillsubHeader=nil;
				if( not skills[skillLineName][skillHeader] ) then
					skills[skillLineName][skillHeader]={};
				end
				--pdb = skills[skillLineName][skillHeader];
			elseif( skillType == "subheader" ) then
				lastHeaderIdx = idx;
				skillsubHeader=skillName;
				if( not skills[skillLineName][skillHeader][skillsubHeader] ) then
					skills[skillLineName][skillHeader][skillsubHeader]={};
				end	
			elseif( skillHeader and skillsubHeader ) then
				cooldown,numMade=nil,nil;
				numReagents = GetTradeSkillNumReagents(idx);
				description = GetTradeSkillDescription(idx)
				reagentlist={};
				reagentids={};
				reagentc = 0;
				local numReagents = GetTradeSkillNumReagents(idx);
				local skillLink = GetTradeSkillItemLink(idx);
				local numMade = GetTradeSkillNumMade(idx);
				for j=1, numReagents, 1 do
					local reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(idx, j);
					local reagentLink = GetTradeSkillReagentItemLink(idx,j);
					reagentID  = frame.GetReagentId( reagentLink );
					table.insert(reagentids,{Item=reagentID,Count=reagentCount,Link=reagentLink});
					if(reagentName) then
						itemName, itemLink, itemRarity, itemLevel, _, itemType, itemSubType, _,_, itemTexture,_ = GetItemInfo(reagentName);
						local ritemColor,_,_,_=frame.GetItemInfo(reagentLink);

					--	reagentID  = frame.GetReagentId( reagentLink );
						GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')
						GameTooltip:SetTradeSkillItem(idx,j); --SetTradeSkillItem(idx)
						tooltip = frame.scantooltip2();
						GameTooltip:Hide()
						color = frame.scanColor(ritemColor);
						itexture = frame.scanIcon(reagentTexture);
						table.insert(reagentlist,{Name=reagentName,Icon=itexture,Tooltip=tooltip,Item=reagentID,Color=color,Count=reagentCount,link=reagentLink});
						reagentc = reagentc+1;
					end
				end

				if (reagentc < numReagents) then
					--wowroster:Print("".. skillLineName ..":".. skillName .." partical scan. scan agian later");
					xstat["Professions"][skillLineName]["errors"] = xstat["Professions"][skillLineName]["errors"]+1;
				end

				GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
				GameTooltip:SetTradeSkillItem(idx) --SetTradeSkillItem(idx)
				tooltip1 = frame.scantooltip2()
				GameTooltip:Hide()
				tooltip = tooltip1 or "";
				local temColor,_,itemID,itemName=frame.GetItemInfo(GetTradeSkillItemLink(idx));
				local Icon = GetTradeSkillIcon(idx) or "";
				
				if (not skills[skillLineName][skillHeader][skillsubHeader][skillName] ) then
					skills[skillLineName][skillHeader][skillsubHeader][skillName] = {};
				end
				
				skills[skillLineName][skillHeader][skillsubHeader][skillName]={
					RecipeID  = frame.GetRecipeId( GetTradeSkillRecipeLink(idx) ) or "",
					Difficulty= skillType or "",
					Color = frame.scanColor(temColor) or "",
					numMade = GetTradeSkillNumMade(idx) or "",
					itemLink= GetTradeSkillItemLink(idx) or "",
					Reagentsnum = numReagents or "0",
					Reagents = reagentlist or "",
					ReagentIds = reagentids or "",
					Icon = frame.scanIcon(Icon) or "",
					desc  = description or "",
					Tooltip	= tooltip,
				};
				cnt = cnt+1; 
			
			elseif( skillHeader and not skillsubHeader) then
				cooldown,numMade=nil,nil;
				numReagents = GetTradeSkillNumReagents(idx);
				description = GetTradeSkillDescription(idx)
				reagentlist={};
				reagentids={};
				reagentc = 0;
				local numReagents = GetTradeSkillNumReagents(idx);
				local skillLink = GetTradeSkillItemLink(idx);
				local numMade = GetTradeSkillNumMade(idx);
				for j=1, numReagents, 1 do
					local reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(idx, j);
					local reagentLink = GetTradeSkillReagentItemLink(idx,j);
					reagentID  = frame.GetReagentId( reagentLink );
					table.insert(reagentids,{Item=reagentID,Count=reagentCount,Link=reagentLink});
					if(reagentName) then
						itemName, itemLink, itemRarity, itemLevel, _, itemType, itemSubType, _,_, itemTexture,_ = GetItemInfo(reagentName);
						local ritemColor,_,_,_=frame.GetItemInfo(reagentLink);

					--	reagentID  = frame.GetReagentId( reagentLink );
						GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')
						GameTooltip:SetTradeSkillItem(idx,j); --SetTradeSkillItem(idx)
						tooltip = frame.scantooltip2();
						GameTooltip:Hide()
						color = frame.scanColor(ritemColor);
						itexture = frame.scanIcon(reagentTexture);
						table.insert(reagentlist,{Name=reagentName,Icon=itexture,Tooltip=tooltip,Item=reagentID,Color=color,Count=reagentCount,link=reagentLink});
						reagentc = reagentc+1;
					end
				end

				if (reagentc < numReagents) then
					--wowroster:Print("".. skillLineName ..":".. skillName .." partical scan. scan agian later");
					xstat["Professions"][skillLineName]["errors"] = xstat["Professions"][skillLineName]["errors"]+1;
				end

				GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
				GameTooltip:SetTradeSkillItem(idx) --SetTradeSkillItem(idx)
				tooltip1 = frame.scantooltip2()
				GameTooltip:Hide()
				tooltip = tooltip1 or "";
				local temColor,_,itemID,itemName=frame.GetItemInfo(GetTradeSkillItemLink(idx));
				local Icon = GetTradeSkillIcon(idx) or "";
				skills[skillLineName][skillHeader][skillName]={
					RecipeID  = frame.GetRecipeId( GetTradeSkillRecipeLink(idx) ) or "",
					Difficulty= skillType or "",
					Color = frame.scanColor(temColor) or "",
					numMade = GetTradeSkillNumMade(idx) or "",
					itemLink= GetTradeSkillItemLink(idx) or "",
					Reagentsnum = numReagents or "0",
					Reagents = reagentlist or "",
					ReagentIds = reagentids or "",
					Icon = frame.scanIcon(Icon) or "",
					desc  = description or "",
					Tooltip	= tooltip,
				};
				cnt = cnt+1; 
			end
		end
	end
	xstat["Professions"][skillLineName]["ct"] = cnt;
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Professions"] = skills
end

frame.GetReagentId = function(itemStr)
	if(itemStr) then 
		local _,_,itemid,_,_,_,_,_,_,_=string.find(itemStr,"([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+)");
		if( itemid ~= 0) then
			--frame:Print("has gem "..gid1.." "..gid2.." "..gid3.."");
			return itemid;
		else
			return nil;
		end
	end
	return nil;
end

frame.GetRecipeId = function(recipeStr)
	local id;
	if(recipeStr) then _,_,id = string.find(recipeStr, "|Henchant:(%d+)|h"); end
	return tonumber(id);
end

frame.GetItemID = function(itemStr)
	local id,rid;
	if(itemStr) then _,_,id,rid=string.find(itemStr,"|Hitem:(%d+):[-%d]+:[-%d]+:[-%d]+:[-%d]+:[-%d]+:([-%d]+):[-%d]+:[%d]+|h"); end
	return tonumber(id),tonumber(rid);
end

function frame:SKILLS()
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	
	if ( not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Skills"] ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Skills"]={};
	end

	local structSkills=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Skills"];
	
	--structSkills = {};
	structSkills["Secondary Skills"]={};
	structSkills["Professions"]={};

	if prof1 then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier = GetProfessionInfo(prof1);
		structSkills["Professions"][name] = skillLevel..":"..maxSkillLevel;
	end

	if prof2 then
		local name2, icon2, skillLevel2, maxSkillLevel2, numAbilities2, spelloffset2, skillLine2, skillModifier2 = GetProfessionInfo(prof2);
		structSkills["Professions"][name2] = skillLevel2..":"..maxSkillLevel2;
		structSkills["Professions"]["Order"] = "1";
	end

	if archaeology then
		local namea, icona, skillLevela, maxSkillLevela, numAbilitiesa, spelloffseta, skillLinea, skillModifiera = GetProfessionInfo(archaeology);
		structSkills["Secondary Skills"][namea] = skillLevela..":"..maxSkillLevela;
		--structSkills["Secondary Skills"][namea]["test"] = skillLinea;
	end

	if fishing then
		local nameb, iconb, skillLevelb, maxSkillLevelb, numAbilitiesb, spelloffsetb, skillLineb, skillModifierb = GetProfessionInfo(fishing);
		structSkills["Secondary Skills"][nameb] = skillLevelb..":"..maxSkillLevelb;
	end

	if cooking then
		local namec, iconc, skillLevelc, maxSkillLevelc, numAbilitiesc, spelloffsetc, skillLinec, skillModifierc = GetProfessionInfo(cooking);
		structSkills["Secondary Skills"][namec] = skillLevelc..":"..maxSkillLevelc;
	end

	if firstAid then
		local named, icond, skillLeveld, maxSkillLeveld, numAbilitiesd, spelloffsetd, skillLined, skillModifierd = GetProfessionInfo(firstAid);
		structSkills["Secondary Skills"][named] = skillLeveld..":"..maxSkillLeveld;
		structSkills["Secondary Skills"]["Order"] = "2";
	end

end
--[[
	begin spellbook functions
]]--
function frame:GetSpellBook()
	if(not wowrpref["scan"]["spells"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["SpellBook"]=nil;
		return;
	end
	if ( not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["SpellBook"] ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["SpellBook"]={};
	end
	if ( not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["SpellBook"] ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["SpellBook"] = {};
	end

	local Spelltotal = 0
	local structSpell=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["SpellBook"];
	for spellTab=1,GetNumSpellTabs() do
		local spellTabname,spellTabtexture,offset,numSpells,isGuild, offSpecID=GetSpellTabInfo(spellTab);
		local isOffSpec = (offSpecID ~= 0);
		local cnt=0;
		if(not xstat["SpellBook"][spellTabname] or xstat["SpellBook"][spellTabname]~=numSpells) then
			if (not spellTabtexture) then spellTabtexture = "achievement_guildperk_fasttrack_rank2"; end
			structSpell[spellTabname]={
				Icon	= frame.scanIcon(spellTabtexture),
				OffSpec = isOffSpec,
				Spells	= {},
			};
			xstat["SpellBook"][spellTabname]=0;
			cnt=0;
			for spellId=1+offset,numSpells+offset do
				local spellName, spellRank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(spellId,BOOKTYPE_SPELL)
				if ( spellName ) then
					structSpell[spellTabname]["Spells"][spellName] = frame:ScanSpellInfo(spellId,BOOKTYPE_SPELL);
					cnt=cnt+1;
					Spelltotal = Spelltotal+1;
				end
			end
			xstat["SpellBook"][spellTabname]=cnt;
			structSpell[spellTabname]["Count"]=numSpells;
		end
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["SpellBook"]=time();
	end
end

function frame:ScanSpellInfo(idx,bookType)
	if(not idx or not bookType ) then return end

	local spellName, spellRank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(idx,bookType);

	GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
	GameTooltip:SetSpellBookItem(idx,bookType);
	tooltip = frame.scantooltip2()
	GameTooltip:Hide()

	if( spellRank and spellRank == "" ) then
		spellRank = nil;
	end
	local structSpellInfo={
		SpellId	= frame.GetSpellID( GetSpellLink( spellName,spellRank ) ),
		Icon	= frame.scanIcon(icon),
		Rank	= spellRank,
		Tooltip	= tooltip
	};
	return structSpellInfo;
end

frame.GetSpellID = function(spellStr)
	local id;
	if(spellStr) then _,_,id=string.find(spellStr,"|Hspell:(%d+)|h"); end
	return tonumber(id);
end

function frame:GetInventory()
	if(not wowrpref["scan"]["inventory"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Inventory"]=nil;
		return;
	end
	
	if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Inventory"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Inventory"]={};
	end

	local structInventory=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Inventory"];
	local containers={};
	for bagid=0,NUM_BAG_FRAMES do
		table.insert(containers,bagid);
	end
	if(HasKey and HasKey()) then
		table.insert(containers,KEYRING_CONTAINER);
	end
	for bagidx,bagid in pairs(containers) do
		bagidx=bagidx-1;
		if(not xstat["Inventory"][bagidx] or not xstat["Bag"][bagid]) then
			structInventory["Bag"..bagidx]=frame:ScanContainer("Inventory",bagidx,bagid);
		end
	end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Inventory"]=time();
end

function frame:GetBank()
	if(not wowrpref["scan"]["bank"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Bank"]=nil;
		return;
	elseif(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Bank"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Bank"]={};
	end

	local structBank=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Bank"];
	local containers={};
	table.insert(containers,BANK_CONTAINER);

	for bagid=1,NUM_BANKBAGSLOTS do
		table.insert(containers,bagid+NUM_BAG_SLOTS);
	end

	for bagidx,bagid in pairs(containers) do
		bagidx=bagidx-1;
		if(not xstat["Bank"][bagidx] or not xstat["Bag"][bagid]) then
			structBank["Bag"..bagidx]=frame:ScanContainer("Bank",bagidx,bagid);
		end
	end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Bank"]=time();
end

function frame:ScanContainer(invgrp,bagidx,bagid)
	local itemColor,itemID,itemName,itemIcon,itemLink;

	local function numNil(num)
		if(wowrpref["fixquantity"] and num and num<=1) then return nil
		else return num
		end
	end

	if(bagid==0) then
		itemName=GetBagName(bagid);
		itemIcon="Button-Backpack-Up";
		if(not wowrpref["fixicon"]) then
			itemIcon="Interface\\Buttons\\"..itemIcon;
		end
		if (itemName) then
			GameTooltip:SetText(""..itemName.."",_,_,_,_);
		end
		GameTooltip:AddLine(format(CONTAINER_SLOTS,frame.GetContainerNumSlots(bagid),BAGSLOT));
	elseif(bagid==BANK_CONTAINER) then
		itemName = "Bank Contents";
	elseif(bagid==KEYRING_CONTAINER) then
		itemName = KEYRING;
		itemIcon="UI-Button-KeyRing";
		if(not wowrpref["fixicon"]) then
			itemIcon="Interface\\Buttons\\"..itemIcon;
		end
		GameTooltip:SetText(itemName);
		tooltip = frame.scantooltip2()
		GameTooltip:Hide()
	else
		local invID = ContainerIDToInventoryID(bagid)
		itemColor,_,itemID,itemName=frame.GetItemInfo( GetInventoryItemLink("player",ContainerIDToInventoryID(bagid)) );
		itemIcon=GetInventoryItemTexture("player",ContainerIDToInventoryID(bagid));	
		GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
		GameTooltip:SetInventoryItem("player",invID)
		tooltip = frame.scantooltip2()
		GameTooltip:Hide()
	end

	local bagSlot = GetContainerNumSlots(bagid)
	local bagInv = 0;
	if(bagSlot==nil or bagSlot==0) then
		xstat[invgrp][bagidx]=nil
		return nil;
	end

	local container={
		Name	= itemName,
		Color	= frame.scanColor(itemColor),
		Slots	= frame.GetContainerNumSlots(bagid),
		Item	= itemID,
		Icon	= frame.scanIcon(itemIcon),
		Tooltip	= tooltip,
		Contents= {}
	};

	for slot=1,bagSlot do
		local itemLink=GetContainerItemLink(bagid,slot);
		if(itemLink) then
			local itemIcon,itemCount,_,_=GetContainerItemInfo(bagid,slot);
			container["Contents"][slot]=frame:ScanItemInfo(itemLink,itemIcon,itemCount,slot,bagid);
			bagInv=bagInv+1;
		end
	end

	xstat["Bag"][bagid]=true;
	xstat[invgrp][bagidx]={slot=bagSlot,inv=bagInv};
	return container
end

function frame:ScanCurrency(force)
	if( not GetCurrencyListSize ) then return end;
	--if(not wowrpref["scan"]["currency"]) then
	--	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Currency"]=nil;
	--	return;
	--end

	local toCollapse={};
	for idx=GetCurrencyListSize(),1,-1 do
		local _,isHeader,isExpanded=GetCurrencyListInfo(idx);
		if(isHeader and not isExpanded) then
			table.insert(toCollapse,idx);
			ExpandCurrencyList(idx,1);
		end
	end

	if( force or (xstat["Currency"]~=GetCurrencyListSize()) ) then
		if (not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Currency"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Currency"]={};
		end
		local structCurrency = WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Currency"];
		local thisHeader;
		local cnt = 0;
		local name,isHeader,isExpanded,isUnused,isWatched,count,extraCurrencyType,icon;
		for idx=1,GetCurrencyListSize() do
			name, isHeader, isExpanded, isUnused, isWatched, count, extraCurrencyType, icon, itemID = GetCurrencyListInfo(idx);
			if ( name and name ~= "" ) then
				if ( isHeader ) then
					thisHeader=name;
					structCurrency[thisHeader]={};
				else
					if ( extraCurrencyType ~= 0 ) then
					end
					GameTooltip:SetCurrencyToken(idx)
					tooltip = frame.scantooltip2()
					if( not isWatched ) then
						isWatched=nil;
					end

					structCurrency[thisHeader][name] = {
						Name	= name,
						Watched	= isWatched,
						Count	= count,
						Icon	= frame.scanIcon(extraCurrencyType),
						Tooltip	= tooltip,
					};
				end
				cnt=cnt+1;
			end
		end
		xstat["Currency"]=cnt;
	end

	table.sort(toCollapse);
	for _,idx in pairs(toCollapse) do
		ExpandCurrencyList(idx,0);
	end
end

--[GetReputation]
function frame:GetReputation()
	--if(not wowrpref["scan"]["reputation"]) then
	--	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Reputation"]=nil;
	--	return;
	--end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Reputation"]={};
	xstat["Reputation"]=0;
	local toCollapse={};
	for idx=GetNumFactions(),1,-1 do
		local _,_,_,_,_,_,_,_,isHeader,isCollapsed=GetFactionInfo(idx);
		if(isHeader and isCollapsed) then
			table.insert(toCollapse,idx);
			ExpandFactionHeader(idx);
		end
	end

	local thisHeader,thisSubHeader,numFactions,structRep = NONE,NONE,GetNumFactions(),{};
	structRep["Count"]=numFactions;
	for idx=1,numFactions do
		local name,description,standingId,bottomValue,topValue,earnedValue,atWarWith,canToggleAtWar,isHeader,isCollapsed,hasRep,isWatched,isChild = GetFactionInfo(idx);
		local item;
		if(isHeader and (not isChild)) then --Super category, like 'Classic' or 'The Burning Crusade'
			thisHeader=name;
			thisSubHeader=NONE;
			structRep[thisHeader]={};
			item=structRep[thisHeader];
		elseif((not isHeader) and (not isChild)) then --Supercategory member, like 'Darkmoon Faire' or 'Thrallmar'
			structRep[thisHeader][name]={};
			item=structRep[thisHeader][name];
		elseif(isHeader and isChild) then --Subcategory, like 'Horde Forces' or 'Shattrath City'
			thisSubHeader=name;
			structRep[thisHeader][thisSubHeader]={};
			item=structRep[thisHeader][thisSubHeader];
		elseif((not isHeader) and isChild) then --Subcategory member, like 'Orgrimmar' or 'Lower City'
			structRep[thisHeader][thisSubHeader][name]={};
			item=structRep[thisHeader][thisSubHeader][name];
		end

		item["Description"] = description;
		item["Standing"] = getglobal("FACTION_STANDING_LABEL"..standingId);
		item["AtWar"] = atWarWith or 0;
		item["Value"] = earnedValue-bottomValue..":"..topValue-bottomValue;
		xstat["Reputation"]=xstat["Reputation"]+1;
	end

	table.sort(toCollapse);
	for _,idx in pairs(toCollapse) do
		CollapseFactionHeader(idx);
	end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Reputation"] = structRep;
end

function frame:GetHonor()
	if(not wowrpref["scan"]["honor"]) then
		return;
	end
	local lifetimeHK,lifetimeRank=GetPVPLifetimeStats();
	if(xstat["Honor"]~=lifetimeHK) then
		if (not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"]={};
		end
		local structHonor=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"];
		local rankName,rankNumber=GetPVPRankInfo(lifetimeRank);
		local sessionHK,sessionCP=GetPVPSessionStats();
		local GetArenaCurrency = GetArenaCurrency or function() return select(2,GetCurrencyInfo(390)) or 0 end
		local GetHonorCurrency = GetHonorCurrency or function() return select(2,GetCurrencyInfo(392)) or 0 end

		if ( not rankName ) then rankName=NONE; end
		structHonor["Lifetime"]={
			Rank=rankNumber,
			Name=rankName,
			HK=lifetimeHK
		};
		structHonor["Current"]={
			Rank=0,
			Name=NONE,
			Icon="",
			Progress=0,
			HonorPoints=GetHonorCurrency(),
			ArenaPoints=GetArenaCurrency()
		};
		structHonor["Session"]={HK=sessionHK,CP=sessionCP};
		structHonor["Yesterday"]=frame.Arg2Tab("HK","CP",GetPVPYesterdayStats());

		xstat["Honor"]=lifetimeHK;
	end
end

function frame:GetArena()
	if(not wowrpref["scan"]["honor"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"]=nil;
		return;
	end
	--PVPFrame_Update();
	local arenaGames = 0;
	local ARENA_TEAMS = {};
	ARENA_TEAMS[1] = {size = 2};
	ARENA_TEAMS[2] = {size = 3};
	ARENA_TEAMS[3] = {size = 5};
	for index,value in pairs(ARENA_TEAMS) do
		for i=1, MAX_ARENA_TEAMS do
			ArenaTeamRoster(i);
			local _, teamSize, _, _, _, seasonTeamPlayed = GetArenaTeam(i);
			if ( value.size == teamSize ) then
				value.index = i;
				arenaGames = arenaGames + seasonTeamPlayed;
			end
		end
	end
	if (not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"]={};
	end
	structHonor = WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Honor"];
	if(xstat["Arena"]~=arenaGames) then
		arenaGames = 0;
		for index,value in pairs(ARENA_TEAMS) do
			local key = value.size..'v'..value.size;
			if ( value.index ) then
				if(not structHonor[key]) then
					structHonor[key] = {};
				end
				local teamName, teamSize, teamRating, teamPlayed, teamWins, seasonTeamPlayed, seasonTeamWins, playerPlayed, seasonPlayerPlayed, teamRank, playerRating = GetArenaTeam(value.index);
				structHonor[key]['Name'] = teamName;
				structHonor[key]['Size'] = teamSize;
				structHonor[key]['Rating'] = teamRating;
				structHonor[key]['Rank'] = teamRank;
				structHonor[key]['PlayerRating'] = playerRating;
				structHonor[key]['Week'] = {Games=teamPlayed,Wins=teamWins,Played=playerPlayed};
				structHonor[key]['Season'] = {Games=seasonTeamPlayed,Wins=seasonTeamWins,Played=seasonPlayerPlayed};

				local teamNumMembers = GetNumArenaTeamMembers(value.index,true);
				if( teamNumMembers ~= 0 ) then
					structHonor[key]['NumMembers'] = teamNumMembers;
					arenaGames = arenaGames + seasonTeamPlayed;
				elseif( not structHonor[key]['NumMembers'] ) then
					structHonor[key]['NumMembers'] = '';
				end
			else
				structHonor[key]=nil;
			end
		end
		xstat["Arena"]=arenaGames;
	end
end

--[GetQuests]
function frame:GetQuests(force)
	if(not wowrpref["scan"]["quests"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Quests"]=nil;
		return;
	end

	local selected=GetQuestLogSelection();
	local toCollapse={};
	for idx=GetNumQuestLogEntries(),1,-1 do
		_,_,_,_,isHeader,isCollapsed,_ = GetQuestLogTitle(idx);
		if(isHeader and isCollapsed) then
			table.insert(toCollapse,idx);
			ExpandQuestHeader(idx);
		end
	end

	local numEntries,numQuests=GetNumQuestLogEntries();

	local function GetDifficultyValue(level)
		local levelDiff = level - UnitLevel("player");
		local color
		if ( levelDiff >= 5 ) then
			color = 4;
		elseif ( levelDiff >= 3 ) then
			color = 3;
		elseif ( levelDiff >= -2 ) then
			color = 2;
		elseif ( -levelDiff <= GetQuestGreenRange() ) then
			color = 1;
		else
			color = 0;
		end
		return color;
	end

	if( force or (xstat["QuestsLog"]~=numEntries) ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Quests"]={};
		xstat["Quests"]=0;
		xstat["QuestsLog"]=0;
		local slot,num,header,structQuest = 1,nil,UNKNOWN,WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Quests"];
		for idx=1,numEntries do
			local questDescription,questObjective;
			local questId = frame.GetQuestID( GetQuestLink(idx) );
			local questTitle,questLevel,questTag,suggestedGroup,isHeader,isCollapsed,isComplete,isDaily = GetQuestLogTitle(idx);
			if(questTitle) then
				if(isHeader) then
					header=questTitle;
					if(not structQuest[header]) then
						structQuest[header]={}
					end
				else
					SelectQuestLogEntry(idx);
					if(suggestedGroup and tonumber(suggestedGroup) and suggestedGroup<=1) then
						suggestedGroup=nil;
					end
					--if(wowrpref["questsfull"]) then
					--	questDescription,questObjective = GetQuestLogQuestText(idx);
					--end
					structQuest[header][slot]={
						QuestId	=questId,
						Title	=questTitle,
						Level	=questLevel,
						Complete=isComplete,
						Daily	=isDaily,
						Tag		=questTag,
						Difficulty=GetDifficultyValue(questLevel),
						Group=suggestedGroup,
						Description=questDescription,
						Objective=questObjective
					};

					num=GetNumQuestLeaderBoards(idx);
					if(num and num > 0) then
						structQuest[header][slot]["Tasks"]={};
						for idx2=1,num do
							structQuest[header][slot]["Tasks"][idx2]=frame.Arg2Tab("Note","Type","Done",GetQuestLogLeaderBoard(idx2,idx));
						end
					end
					num=GetQuestLogRewardMoney(idx);
					if(num and num > 0) then
						structQuest[header][slot]["RewardMoney"]=num;
					end
					num=GetNumQuestLogRewards(idx);
					if(num and num > 0) then
						structQuest[header][slot]["Rewards"]={};
						for idx2=1,num do
							_,curItemTexture,itemCount,_,_=GetQuestLogRewardInfo(idx2);
							GameTooltip:SetQuestLogItem("reward",idx2);
							table.insert(structQuest[header][slot]["Rewards"],frame:ScanItemInfo(GetQuestLogItemLink("reward",idx2),curItemTexture,itemCount));
						end
					end
					num=GetNumQuestLogChoices(idx);
					if(num and num > 0) then
						structQuest[header][slot]["Choice"]={};
						for idx2=1,num do
							_,curItemTexture,itemCount,_,_=GetQuestLogChoiceInfo(idx2);
							GameTooltip:SetQuestLogItem("choice",idx2);
							table.insert(structQuest[header][slot]["Choice"],frame:ScanItemInfo(GetQuestLogItemLink("choice",idx2),curItemTexture,itemCount));
						end
					end
					slot=slot+1;
					xstat["Quests"] = xstat["Quests"]+1;
				end
			end
			xstat["QuestsLog"] = xstat["QuestsLog"]+1;
		end
	end

	table.sort(toCollapse);
	for _,idx in pairs(toCollapse) do
		CollapseQuestHeader(idx);
	end
	SelectQuestLogEntry(selected);
end
isWild = false;
local petOwner, petIndex, abilityIndex;

function frame:ScanPetBattle()

	--local numPets = C_PetJournal.GetNumPets(isWild);
	if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["PetBattle"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["PetBattle"]={};
		end
	local numPets, numOwned = C_PetJournal.GetNumPets(isWild);
	local structBpets=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["PetBattle"];
	for p = 1,numPets do
	
		local ID, speciesID, owned = C_PetJournal.GetPetInfoByIndex(p, isWild);
		local petID, speciesID, owned = C_PetJournal.GetPetInfoByIndex(p, isWild);
		C_PetJournal.petID =  petID;
		if (owned and petID) then
			
			local speciesID, customName, level, Petname, icon, petType, creatureID, xp, maxXp, displayID, sourceText, description, isWild, canBattle, tradable;
			speciesID, customName, level, xp, maxXp, displayID, Petname, bicon, petType, ccreatureID, sourceText, description, isWild, canBattle, tradable = C_PetJournal.GetPetInfoByPetID(ID);
			
			if canBattle then

				structBpets[p] = {};
				health, maxHealth, power, speed, rarity = C_PetJournal.GetPetStats(ID);
				
				local xnamex, iconx, _, _, _, _, _, canBattle, tradable = C_PetJournal.GetPetInfoBySpeciesID(speciesID);
				
				GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
				GameTooltip:SetItemByID(petID);
				tooltip = frame.scantooltip2()
				GameTooltip:Hide()
						
				structBpets[p] = {
						CName		=	customName,
						Level		=	level,
						XP			=	xp,
						MaxXp		=	maxXp,
						Name		=	Petname,
						Texture		=	frame.scanIcon(iconx),
						Tooltip		=	tooltip,
						Health		=	health,
						MaxHealth	=	maxHealth,
						Power		=	power,
						Speed		=	speed,
						Rarity		=	rarity,
						Type		=	petType,
						CreatureID	=	creatureID,
						SText		=	sourceText,
						Description	=	description,
						Species		=	speciesID,
						IsWild		=	isWild
					};
				
				if (speciesID) then
				--[[
					structBpets[p]["data"] = {};
					structBpets[p]["data"] = {
						Species		=	speciesID,
						CName		=	customName,
						Level		=	level,
						XP			=	xp,
						MaxXp		=	maxXp,
						DisplayID	=	displayID,
						Name		=	Petname,
						Health		=	health,
						MaxHealth	=	maxHealth,
						Power		=	power,
						Speed		=	speed,
						Rarity		=	rarity,
				--		AIcon		=	frame.scanIcon(aicon),
						BIcon		=	frame.scanIcon(bicon),
						Type		=	petType,
						CreatureID	=	creatureID,
						SText		=	sourceText,
						Description	=	description,
						IsWild		=	isWild
					}; ]]--
					local abilities, levels = C_PetJournal.GetPetAbilityList(speciesID);
					structBpets[p]["spells"] = {};

					for i=1,6 do
					structBpets[p]["spells"][i] = {};
						if abilities[i] and canBattle then
							local fname, icon, petType = C_PetJournal.GetPetAbilityInfo(abilities[i]);
							local aid, aname, aicon, amaxCooldown, adescription, anumTurns, apetType = C_PetBattles.GetAbilityInfoByID(abilities[i]);
		
							local isNotUsable = not level or level < levels[i];
							SharedPetBattleAbilityTooltip_GetInfoTable()
							C_PetBattles.GetAllStates(parserEnv);
							local abilityInfo = {};
								setmetatable(abilityInfo, {__index = PET_JOURNAL_ABILITY_INFO});
								abilityInfo.abilityID = aid;
								abilityInfo.speciesID = speciesID;
								abilityInfo.petID = petID;
								abilityInfo.petIndex = p;
								abilityInfo.abilityIndex = i;
								abilityInfo.petOwner = "player";
							local xdescription = SharedPetAbilityTooltip_ParseText(abilityInfo, adescription);

							if (not level or level < levels[i]) then
								tooltip = format(PET_ABILITY_REQUIRES_LEVEL, levels[i]);
							else

								--frame:BPToolTip(speciesID, level, rarity, maxHealth, power, speed, customName)

								GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
								--PetJournal_ShowAbilityTooltip('PetBattlePrimaryAbilityTooltip', abilities[i], speciesID, petID);
								FloatingBattlePet_Show(speciesID, level, rarity, maxHealth, power, speed, customName, petID);
								FloatingPetBattleAbility_Show(aid, maxHealth, power, speed);

								tooltip = FloatingPetBattleAbilityTooltip.Description:GetText();--frame.scantooltip4();
								StrongAgainstL	= FloatingPetBattleAbilityTooltip.StrongAgainstLabel:GetText();
								StrongAgainstT 	= FloatingPetBattleAbilityTooltip.StrongAgainstType1Label:GetText();
								WeakAgainstL	= FloatingPetBattleAbilityTooltip.WeakAgainstLabel:GetText();
								WeakAgainstT 	= FloatingPetBattleAbilityTooltip.WeakAgainstType1Label:GetText();
								--tooltipa = frame.scantooltip3(); --C_PetJournal.GetPetLoadOutInfo(i)-- frame:BuildPetTooltipString(ID)--frame.scantooltip3();
								--PetJournalPrimaryAbilityTooltip:Hide();
								GameTooltip:Hide();
								FloatingBattlePetTooltip:Hide();
								FloatingPetBattleAbilityTooltip:Hide();
								
							end
							
							tooltip=string.gsub(tooltip,"\n","<br>");
							tooltip=string.gsub(tooltip,"\r","");
					
							structBpets[p]["spells"][i] = {
								Icon		=	frame.scanIcon(icon),
								Name		=	fname,
								Text		=	levels[i],
								Tooltip		=	tooltip,
								ReqLevel	=	req,
								SpellID		=	abilities[i],
								MaxCd		=	amaxCooldown,
								NumTurns	=	anumTurns,
								--StrongAgainstLabel = StrongAgainstL,
								StrongAgainstType = StrongAgainstT,
								--WeakAgainstLabel = WeakAgainstL,
								WeakAgainstType = WeakAgainstT,
							};

						end
					end

				end
			end
		end
	end
end
--PetJournalPrimaryAbilityTooltip

local petTypePassiveChart = {
  [1] = {4, 5},  -- Humanoid    +Undead      -Critter
  [2] = {1, 3},  -- Dragon      +Humanoid    -Flying
  [3] = {6, 8},  -- Flying      +Magical     -Beast
  [4] = {5, 2},  -- Undead      +Critter     -Dragon
  [5] = {8, 1},  -- Critter     +Beast       -Humanoid
  [6] = {2, 9},  -- Magical     +Dragon      -Water
  [7] = {9, 10}, -- Elemental   +Water       -Mechanical
  [8] = {10, 1}, -- Beast       +Mechanical  -Humanoid
  [9] = {3, 4},  -- Water       +Flying      -Undead
  [10] = {7, 6}, -- Mechanical  +Elemental   -Magical
}

function frame:BPToolTip(speciesID, level, breedQuality, maxHealth, power, speed, customName)
local BATTLE_PET_TOOLTIP = {};
	if (speciesID and speciesID > 0) then
		local name, icon, petType = C_PetJournal.GetPetInfoBySpeciesID(speciesID);
		BATTLE_PET_TOOLTIP.speciesID = speciesID;
		BATTLE_PET_TOOLTIP.name = name;
		BATTLE_PET_TOOLTIP.Name = name;
		BATTLE_PET_TOOLTIP.level = level;
		BATTLE_PET_TOOLTIP.breedQuality = breedQuality;
		BATTLE_PET_TOOLTIP.petType = petType;
		BATTLE_PET_TOOLTIP.maxHealth = maxHealth;
		BATTLE_PET_TOOLTIP.power = power;
		BATTLE_PET_TOOLTIP.speed = speed;
		if (customName ~= BATTLE_PET_TOOLTIP.name) then
			BATTLE_PET_TOOLTIP.customName = customName;
		else
			BATTLE_PET_TOOLTIP.customName = nil;
		end

		BattlePetTooltipTemplate_SetBattlePet(BattlePetTooltip, BATTLE_PET_TOOLTIP);

	end
end

function frame:ScanCompanions()
	--if( not GetNumCompanions) then return; end

	--if(wowrpref["scan"]["companions"]) then
		local crittertypes={"Critter","Mount"};

		if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Companions"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Companions"]={};
		end
		if(not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Companions"]) then
			WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Companions"]={};
		end
		structCompanions = WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Companions"];
		for index,companionType in pairs(crittertypes) do
			local numCompanions = GetNumCompanions(companionType);
			if(not structCompanions[companionType]) then
				structCompanions[companionType]={};
			end

			if( xstat["Companions"][companionType] ~= numCompanions ) then
				xstat["Companions"][companionType] = 0;
				for companionIndex=1,numCompanions do
					local creatureID,creatureName,spellID,icon,active = GetCompanionInfo(companionType,companionIndex);

					if(creatureName and creatureName~=UNKNOWN) then
						GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
						GameTooltip:SetSpellByID(spellID)
						tooltip = frame.scantooltip2()
						GameTooltip:Hide()
						structCompanions[companionType][companionIndex] = {
							Name		= creatureName,
							CreatureID	= creatureID,
							SpellId		= spellID,
							Active		= active,
							Icon		= frame.scanIcon(icon),
							Tooltip		= tooltip,
						};
					end
					
					xstat["Companions"][companionType] = xstat["Companions"][companionType]+1;
				end
				WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Companions"][companionType] = time();
			end
		end
	--elseif(WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]) then
	--	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Companions"]=nil;
	--	xstat["Companions"]={};
	--end
end

function frame:GetEquipment(force)
	if(not wowrpref["scan"]["equipment"]) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Equipment"]=nil;
		return;
	end

	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Equipment"]={};
	xstat["Equipment"] = 0;

	local structEquip=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Equipment"];
	for index,slot in pairs(UnitSlots) do
		local itemLink,itemCount;
		local itemTexture = GetInventoryItemTexture("player",index);
		local headSlot = getglobal("Character"..slot);

		itemLink = GetInventoryItemLink("player",index);
		if(itemLink) then
			itemCount=GetInventoryItemCount("player",index);
			if(itemCount == 1) then itemCount=nil; end

			structEquip[slot]=frame:ScanItemInfo(itemLink,itemTexture,itemCount,index,"player");
			xstat["Equipment"]=xstat["Equipment"]+1;
			itemLink=nil;
		end
	end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Equipment"]=time();

	self:GetStats(WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]);
end

local specs = {
	["1"] = {
		name = TALENT_SPEC_PRIMARY,
		nameActive = TALENT_SPEC_PRIMARY_ACTIVE,
		glyphName = TALENT_SPEC_PRIMARY_GLYPH,
		glyphNameActive = TALENT_SPEC_PRIMARY_GLYPH_ACTIVE,
		specName = SPECIALIZATION_PRIMARY,
		specNameActive = SPECIALIZATION_PRIMARY_ACTIVE,
		talentGroup = 1,
		tooltip = TALENT_SPEC_PRIMARY,
		defaultSpecTexture = "Interface\\Icons\\Ability_Marksmanship",
	},
	["2"] = {
		name = TALENT_SPEC_SECONDARY,
		nameActive = TALENT_SPEC_SECONDARY_ACTIVE,
		glyphName = TALENT_SPEC_SECONDARY_GLYPH,
		glyphNameActive = TALENT_SPEC_SECONDARY_GLYPH_ACTIVE,
		specName = SPECIALIZATION_SECONDARY,
		specNameActive = SPECIALIZATION_SECONDARY_ACTIVE,
		talentGroup = 2,
		tooltip = TALENT_SPEC_SECONDARY,
		defaultSpecTexture = "Interface\\Icons\\Ability_Marksmanship",
	},
};
local cache = {};
function frame:GetTalents(unit)
	if(not wowrpref["scan"]["talents"] or UnitLevel("player") < 10 ) then
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Talents"]=nil; return;
	end
	unit = "player";
	local numTabs,numPts,state,petName;
	local numSpecs = GetNumSpecializations(false, "player");
	local structTalent={};
	local structTalents={};

	xstat["Talents"] = {};
	xstat["Glyphs"] = {};

	--cache = {};
	local numTabs = GetNumSpecializations(false);
	cache.numTabs = numTabs;
	for i = 1, 4 do
		cache[i] = cache[i] or { };
		if ( i <= numTabs ) then
			local id, name, description, icon, background = GetSpecializationInfo(i, false);
			local role = GetSpecializationRole(i, false, false);
			cache[i] = cache[id] or { };

			cache[i].name = name;
			cache[i].id = id;
			cache[i].background = background;
			cache[i].description = description;
			cache[i].icon = icon;
			cache[i].role = role;
		else
			cache[i].name = nil;
		end
	end

	numSpecGroups = GetNumSpecGroups(false, "player");
	numTabs=1;--GetNumTalentTabs();
	state = "Talents";
	local tabName,iconTexture,pointsSpent,background;
	local cnt=0;
	local nameTalent,iconTexture,tier,column,currentRank,maxRank,isExceptional,meetsPrereq;
	
	for i = 1, numSpecGroups do
		tindex = i;
		structTalent[tindex]={};
		if (GetActiveSpecGroup(false, "player") == i) then
			Act = true;
		else
			Act = false;
		end
		xstat["Glyphs"][tindex] = 0;
		local id, sname, description, sicon, background= GetSpecializationInfo(i);
		local sid, name, sdescription, icon, sbackground, srole, sclass = GetSpecializationInfoByID(id);
		local SPEC = GetSpecialization(nil, false, i);
		
		structTalent[tindex]={
			Icon	=	frame.scanIcon(cache[SPEC].icon),
			Background	=	frame.scanIcon(cache[SPEC].background),
			Name		=	cache[SPEC].name,
			Desc 		=	cache[SPEC].description,
			Active		=	Act,
			Role		=	cache[SPEC].role,
			SpecId 		=	SPEC,
		};
		xstat["Talents"][tindex] = cache[SPEC].name;
		structTalent[tindex]["Talents"] = {};
		for talentIndex=1,18 do
			--name, iconTexture, tier, column, selected, available = GetTalentInfo(talentIndex ,null, "player", i) 
			name, iconTexture, tier, column, selected, available = GetTalentInfo(talentIndex, "player", i, false, frame.UnitClass("player"));

			if( name ) then			
					GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');
					GameTooltip:SetTalent(talentIndex, "player", i);
					xtooltip = frame.scantooltip2();
					GameTooltip:Hide();

				structTalent[tindex]["Talents"][name]={
					Location	= strjoin(":", tier,column),
					Texture		=	frame.scanIcon(iconTexture),
					Selected	=	selected,
					Available	=	available,
					Tooltip		=	xtooltip,
					Name		=	name,
				};
			end
		end
		local structGlyphs={};
		structTalent[tindex]["Glyphs"] = {};
			for index=1, GetNumGlyphSockets() do
				local enabled, glyphType, glyphTooltipIndex, glyphSpell, icon = GetGlyphSocketInfo(index,i);
				if(enabled == 1 and glyphSpell) then
					GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
					GameTooltip:SetGlyph(index,i);
					local name, link = GameTooltip:GetItem()
					tooltip = frame.scantooltip2()
					GameTooltip:Hide()
					name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(glyphSpell)
					structGlyphs[index] = {
						Name	= name,
						Type	= glyphType,
						Icon	= frame.scanIcon(icon),
						Tooltip	= tooltip,
					};
					xstat["Glyphs"][tindex] = xstat["Glyphs"][tindex]+1;
				else
					structGlyphs[index] = nil;
				end
			end
		structTalent[tindex]["Glyphs"] = structGlyphs;
	end
	WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Talents"]=structTalent;
end

function frame:GetStats(structStats,unit)
	unit = unit or "player";
	if( unit=="player" and (UnitIsDeadOrGhost("player") or frame.UnitHasResSickness("player")) ) then
		return
	end
	if(not structStats["Attributes"]) then
		structStats["Attributes"]={};
	end
	structStats["Level"]=UnitLevel(unit);
	structStats["Health"]=UnitHealthMax(unit);
	structStats["Mana"]=UnitPowerMax(unit);
	structStats["Power"]=UnitPower[UnitPowerType(unit)];
	
	local mastery = GetMasteryEffect();
	mastery = format("%.2F%%", mastery);
	
	structStats["Attributes"]["Mastery"] = {};
	structStats["Attributes"]["Mastery"]["Percent"] = mastery;
	structStats["Attributes"]["Mastery"]["Tooltip"] = frame:GetMastery();
	
	local avgItemLevel, avgItemLevelEquipped = GetAverageItemLevel();
	avgItemLevel = floor(avgItemLevel);
	avgItemLevelEquipped = floor(avgItemLevelEquipped);
	structStats["Attributes"]["ITEMLEVEL"] = avgItemLevelEquipped .. " / " .. avgItemLevel;
	
	local _, runSpeed, flightSpeed, swimSpeed = GetUnitSpeed("player");
	runSpeed = frame.round(runSpeed/7*100,0);
	flightSpeed = frame.round(flightSpeed/7*100,0);
	swimSpeed = frame.round(swimSpeed/7*100,0);
	structStats["Attributes"]["MOVESPEED"] = {};
	structStats["Attributes"]["MOVESPEED"]["Run"] = runSpeed;
	structStats["Attributes"]["MOVESPEED"]["Flight"] = flightSpeed;
	structStats["Attributes"]["MOVESPEED"]["Swim"] = swimSpeed;
	
	structStats["Attributes"]["Stats"]={};
	for i=1,table.getn(UnitStatName) do
		local stat,effectiveStat,posBuff,negBuff=UnitStat(unit,i);
		structStats["Attributes"]["Stats"][UnitStatName[i]] = strjoin(":", (stat - posBuff - negBuff),posBuff,negBuff);
	end
	local base,posBuff,negBuff,modBuff,effBuff,stat;
	base,modBuff = UnitDefense(unit);
	posBuff,negBuff = 0,0;
	if ( modBuff > 0 ) then
		posBuff = modBuff;
	elseif ( modBuff < 0 ) then
		negBuff = modBuff;
	end
	structStats["Attributes"]["Defense"] = {};
	structStats["Attributes"]["Defense"]["Defense"] = strjoin(":", base,posBuff,negBuff);
	base,effBuff,stat,posBuff,negBuff=UnitArmor(unit);
	structStats["Attributes"]["Defense"]["Armor"] = strjoin(":", base,posBuff,negBuff);
	structStats["Attributes"]["Defense"]["ArmorReduction"] = PaperDollFrame_GetArmorReduction(effBuff, UnitLevel("player"));
	base,posBuff,negBuff = GetCombatRating(CR_DEFENSE_SKILL),frame.round(GetCombatRatingBonus(CR_DEFENSE_SKILL),2),0;
	structStats["Attributes"]["Defense"]["DefenseRating"]=strjoin(":", base,posBuff,negBuff);
	structStats["Attributes"]["Defense"]["DefensePercent"]=GetCombatRatingBonus(CR_DEFENSE_SKILL);--GetDodgeBlockParryChanceFromDefense();
	base,posBuff,negBuff = GetCombatRating(CR_DODGE),frame.round(GetCombatRatingBonus(CR_DODGE),2),0;
	structStats["Attributes"]["Defense"]["DodgeRating"]=strjoin(":", base,posBuff,negBuff);
	structStats["Attributes"]["Defense"]["DodgeChance"]=frame.round(GetDodgeChance(),2);
	base,posBuff,negBuff = GetCombatRating(CR_BLOCK),frame.round(GetCombatRatingBonus(CR_BLOCK),2),0;
	structStats["Attributes"]["Defense"]["BlockRating"]=strjoin(":", base,posBuff,negBuff);
	structStats["Attributes"]["Defense"]["BlockChance"]=frame.round(GetBlockChance(),2);
	base,posBuff,negBuff = GetCombatRating(CR_PARRY),frame.round(GetCombatRatingBonus(CR_PARRY),2),0;
	structStats["Attributes"]["Defense"]["ParryRating"]=strjoin(":", base,posBuff,negBuff);
	structStats["Attributes"]["Defense"]["ParryChance"]=frame.round(GetParryChance(),2);
	structStats["Attributes"]["Defense"]["Resilience"]={};
	structStats["Attributes"]["Defense"]["Resilience"]["Melee"]=GetCombatRating(COMBAT_RATING_RESILIENCE_CRIT_TAKEN);
	structStats["Attributes"]["Defense"]["PvPPower"] = GetCombatRating(CR_PVP_POWER);
	structStats["Attributes"]["Defense"]["PvPPowerBonus"] = GetCombatRatingBonus(CR_PVP_POWER);
	
	
	structStats["Attributes"]["Resists"]={};
	for i=1,table.getn(UnitResistanceName) do
		local base,resistance,positive,negative=UnitResistance(unit,i);
		structStats["Attributes"]["Resists"][UnitResistanceName[i]] = strjoin(":", base,positive,negative);
	end
	if(unit=="player") then
		structStats["Hearth"]=GetBindLocation();
		structStats["Money"]=frame.Arg2Tab("Gold","Silver","Copper",frame.parseMoney(GetMoney()));
		structStats["IsResting"]=IsResting() == 1 or false;
		structStats["Experience"]=strjoin(":", UnitXP("player"),UnitXPMax("player"),GetXPExhaustion() or 0);
		self:GetAttackRating(structStats["Attributes"],unit);
		WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["timestamp"]["Attributes"]=time();
	elseif(unit=="pet") then
		self:GetPetAttack(structStats["Attributes"],unit,"Pet");
	else
		self:GetAttackRatingOld(structStats["Attributes"],unit,"Pet");
	end
end
function frame:GetPetAttack(structAttack,unit,prefix)


	local mainHandAttackBase, mainHandAttackMod, offHandHandAttackBase, offHandAttackMod = UnitAttackBothHands("Pet")
	local base, posBuff, negBuff = UnitAttackPower(unit)
	local speed, offhandSpeed = UnitAttackSpeed(unit)
	local minDamage, maxDamage, minOffHandDamage, maxOffHandDamage, physicalBonusPos, physicalBonusNeg, percent = UnitDamage(unit)
	local base, modifier = UnitDefense(unit)
--	local base, resistance, positive, negative = UnitResistance(unit, resistanceIndex)

	local displayMin = max(floor(minDamage),1);
	local displayMax = max(ceil(maxDamage),1);

	minDamage = (minDamage / percent) - physicalBonusPos - physicalBonusNeg;
	maxDamage = (maxDamage / percent) - physicalBonusPos - physicalBonusNeg;

	local baseDamage = (minDamage + maxDamage) * 0.5;
	local fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
	local totalBonus = (fullDamage - baseDamage);
	local damagePerSecond = (max(fullDamage,1) / speed);
	--local damageText = getglobal(statFrame:GetName().."StatText");



	structAttack["Melee"]={};
	structAttack["Melee"]["MainHand"]={};
	structAttack["Melee"]["MainHand"]["AttackSpeed"]=frame.round(speed,2);
	structAttack["Melee"]["MainHand"]["AttackDPS"]=frame.round(damagePerSecond,1);
	structAttack["Melee"]["MainHand"]["AttackRating"]=mainHandAttackBase+mainHandAttackMod;

	--local tt=damageText:GetText();
	--tt=frame.StripColor(tt);
	structAttack["Melee"]["MainHand"]["DamageRange"]=""..frame.round(minDamage,0)..":"..frame.round(maxDamage,0).."";
	
	local base,posBuff,negBuff = UnitAttackPower(unit);
	
	apDPS=max((base+posBuff+negBuff),0)/ATTACK_POWER_MAGIC_NUMBER;
	structAttack["Melee"]["AttackPower"] = strjoin(":", base,posBuff,negBuff);
	structAttack["Melee"]["AttackPowerDPS"]=frame.round(apDPS,1);
	structAttack["Melee"]["AttackPowerTooltip"]=format(MELEE_ATTACK_POWER_TOOLTIP,apDPS);

end

function frame:GetPetSpellBook()
	if(wowrpref["scan"]["spells"]) then
		local petName=UnitName("pet");
		if( petName and petName~=UNKNOWN ) then
			numSpells,_=HasPetSpells();
			if( numSpells ) then
				self:ScanPetInit(petName);
				if (not WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][petName]["SpellBook"]) then
					WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][petName]["SpellBook"]={};
				end
				local structPetSpell=WoWRCP.db[xstat["_server"]]["Character"][xstat["_player"]]["Pets"][petName]["SpellBook"];
				if (not structPetSpell["Spells"]) then
					structPetSpell["Spells"]={};
				end

				local cnt=0;
				for petSpellId=1,numSpells do
	local spellName, spellRank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(petSpellId,BOOKTYPE_PET)
					--local spellName=GetSpellName(petSpellId,BOOKTYPE_PET);
					if ( spellName ) then
						structPetSpell["Spells"][spellName] = frame:ScanSpellInfo(petSpellId,BOOKTYPE_PET);
						cnt=cnt+1;
					end
				end
				structPetSpell["Count"]=cnt;
				xstat["PetSpell"][petName]=cnt;
			end
		end
	end
end

function frame:GetMastery()

	GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');
	
	local _, class = UnitClass("player");
	local mastery, bonusCoeff = GetMasteryEffect();
	local masteryBonus = GetCombatRatingBonus(CR_MASTERY) * bonusCoeff;
	
	local title = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, STAT_MASTERY).." "..format("%.2F%%", mastery)..FONT_COLOR_CODE_CLOSE;
	if (masteryBonus > 0) then
		title = title..HIGHLIGHT_FONT_COLOR_CODE.." ("..format("%.2F%%", mastery-masteryBonus)..FONT_COLOR_CODE_CLOSE..GREEN_FONT_COLOR_CODE.."+"..format("%.2F%%", masteryBonus)..FONT_COLOR_CODE_CLOSE..HIGHLIGHT_FONT_COLOR_CODE..")";
	end
	GameTooltip:SetText(title);
	
	local primaryTalentTree = GetSpecialization();
	if (primaryTalentTree) then
		local masterySpell, masterySpell2 = GetSpecializationMasterySpells(primaryTalentTree);
		if (masterySpell) then
			GameTooltip:AddSpellByID(masterySpell);
		end
		if (masterySpell2) then
			GameTooltip:AddLine(" ");
			GameTooltip:AddSpellByID(masterySpell2);
		end
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(format(STAT_MASTERY_TOOLTIP, GetCombatRating(CR_MASTERY), masteryBonus), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, true);
	else
		GameTooltip:AddLine(format(STAT_MASTERY_TOOLTIP, GetCombatRating(CR_MASTERY), masteryBonus), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, true);
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(STAT_MASTERY_TOOLTIP_NO_TALENT_SPEC, GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b, true);
	end
	xtooltip = frame.scantooltip2();
	GameTooltip:Hide();
	return xtooltip;
end

function frame:CharacterDamageFrame(damageFrame)
	damageFrame = damageFrame or getglobal("PlayerStatFrameLeft1StatText");
	if (not damageFrame.damage) then return; end
	frame.tooltip:ClearLines();
	-- Main hand weapon
	frame.tooltip:SetText(INVTYPE_WEAPONMAINHAND, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	frame.tooltip:AddDoubleLine(ATTACK_SPEED_COLON, format("%.2f", damageFrame.attackSpeed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	frame.tooltip:AddDoubleLine(DAMAGE_COLON, damageFrame.damage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	frame.tooltip:AddDoubleLine(DAMAGE_PER_SECOND, format("%.1f", damageFrame.dps), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	-- Check for offhand weapon
	if ( damageFrame.offhandAttackSpeed ) then
		frame.tooltip:AddLine("\n");
		frame.tooltip:AddLine(INVTYPE_WEAPONOFFHAND, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		frame.tooltip:AddDoubleLine(ATTACK_SPEED_COLON, format("%.2f", damageFrame.offhandAttackSpeed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		frame.tooltip:AddDoubleLine(DAMAGE_COLON, damageFrame.offhandDamage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		frame.tooltip:AddDoubleLine(DAMAGE_PER_SECOND, format("%.1f", damageFrame.offhandDps), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	end
end

function frame:CharacterRangedDamageFrame(damageFrame)
	damageFrame = damageFrame or getglobal("PlayerStatFrameLeft1");
	if (not damageFrame.damage) then return; end
	frame.tooltip:ClearLines();
	frame.tooltip:SetText(INVTYPE_RANGED, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	frame.tooltip:AddDoubleLine(ATTACK_SPEED_COLON, format("%.2f", damageFrame.attackSpeed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	frame.tooltip:AddDoubleLine(DAMAGE_COLON, damageFrame.damage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	frame.tooltip:AddDoubleLine(DAMAGE_PER_SECOND, format("%.1f", damageFrame.dps), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
end

function frame:GetAttackRating(structAttack,unit,prefix)
	unit = unit or "player";
	prefix = prefix or "PlayerStatFrameLeft";

	local stat = getglobal(prefix.."1");
	local stat1 = getglobal(prefix..1)          
	local stat2 = getglobal(prefix..2)          
	local stat3 = getglobal(prefix..3)          
	local stat4 = getglobal(prefix..4)          
	local stat5 = getglobal(prefix..5)          
	local stat6 = getglobal(prefix..6)  

	local mainHandAttackBase,mainHandAttackMod,offHandAttackBase,offHandAttackMod = UnitAttackBothHands(unit);
	local speed,offhandSpeed = UnitAttackSpeed(unit);
	local minDamage;
	local maxDamage; 
	local minOffHandDamage;
	local maxOffHandDamage; 
	local physicalBonusPos;
	local physicalBonusNeg;
	local percent;
	minDamage, maxDamage, minOffHandDamage, maxOffHandDamage, physicalBonusPos, physicalBonusNeg, percent = UnitDamage(unit);
	
	local displayMin = max(floor(minDamage),1);
	local displayMax = max(ceil(maxDamage),1);

	minDamage = (minDamage / percent) - physicalBonusPos - physicalBonusNeg;
	maxDamage = (maxDamage / percent) - physicalBonusPos - physicalBonusNeg;

	local baseDamage = (minDamage + maxDamage) * 0.5;
	local fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
	local totalBonus = (fullDamage - baseDamage);
	local damagePerSecond = (max(fullDamage,1) / speed);

	structAttack["Melee"]={};
	structAttack["Melee"]["Expertise"]=GetExpertise();
	structAttack["Melee"]["MainHand"]={};
	structAttack["Melee"]["MainHand"]["AttackSpeed"]=frame.round(speed,2);
	structAttack["Melee"]["MainHand"]["AttackDPS"]=frame.Percent(damagePerSecond);--frame.round(stat.dps,1);
	structAttack["Melee"]["MainHand"]["AttackSkill"]=mainHandAttackBase+mainHandAttackMod;
	structAttack["Melee"]["MainHand"]["AttackRating"]=strjoin(":", frame.Percent(mainHandAttackBase),frame.Percent(mainHandAttackMod),0);

	structAttack["Melee"]["MainHand"]["DamageRangeBase"]=strjoin(":",frame.Percent(minDamage),frame.Percent(maxDamage));

	if ( offhandSpeed ) then
		minOffHandDamage = (minOffHandDamage / percent) - physicalBonusPos - physicalBonusNeg;
		maxOffHandDamage = (maxOffHandDamage / percent) - physicalBonusPos - physicalBonusNeg;

		local offhandBaseDamage = (minOffHandDamage + maxOffHandDamage) * 0.5;
		local offhandFullDamage = (offhandBaseDamage + physicalBonusPos + physicalBonusNeg) * percent;
		local offhandDamagePerSecond = (max(offhandFullDamage,1) / offhandSpeed);
		local offhandTotalBonus = (offhandFullDamage - offhandBaseDamage);

		structAttack["Melee"]["OffHand"]={};
		structAttack["Melee"]["OffHand"]["AttackSpeed"]=frame.round(offhandSpeed,2);
		structAttack["Melee"]["OffHand"]["AttackDPS"]=offhandDamagePerSecond;--frame.round(stat.offhandDps,1);
		structAttack["Melee"]["OffHand"]["AttackSkill"]=offHandAttackBase+offHandAttackMod;
		structAttack["Melee"]["OffHand"]["AttackRating"]=strjoin(":", offHandAttackBase,offHandAttackMod,0);
	else
		structAttack["Melee"]["OffHand"]=nil;
	end

	local stat4 = getglobal(prefix.."4");
	local base,posBuff,negBuff;
	base,posBuff,negBuff = UnitAttackPower(unit);
	structAttack["Melee"]["AttackPower"] = strjoin(":", base,posBuff,negBuff);
	structAttack["Melee"]["AttackPowerDPS"]=frame.round(max((base+posBuff+negBuff), 0)/ATTACK_POWER_MAGIC_NUMBER,1);
	--structAttack["Melee"]["AttackPowerTooltip"]=stat4.tooltip2;
	base,posBuff,negBuff = GetCombatRating(CR_EXPERTISE),frame.round(GetCombatRatingBonus(CR_EXPERTISE),2),0;
	structAttack["Melee"]["Expertise"]=strjoin(":", base,posBuff,negBuff);
	base,posBuff,negBuff = GetCombatRating(CR_HIT_MELEE),frame.round(GetCombatRatingBonus(CR_HIT_MELEE),2),0;
	structAttack["Melee"]["HitRating"]=strjoin(":", base,posBuff,negBuff);
	base,posBuff,negBuff = GetCombatRating(CR_CRIT_MELEE),frame.round(GetCombatRatingBonus(CR_CRIT_MELEE),2),0;
	structAttack["Melee"]["CritRating"]=strjoin(":", base,posBuff,negBuff);
	base,posBuff,negBuff = GetCombatRating(CR_HASTE_MELEE),frame.round(GetCombatRatingBonus(CR_HASTE_MELEE),2),0;
	structAttack["Melee"]["HasteRating"]=strjoin(":", base,posBuff,negBuff);

	structAttack["Melee"]["CritChance"]=frame.round(GetCritChance(),2);

	if(unit=="player") then
		if ( not GetInventoryItemTexture(unit,16) and not UnitHasRelicSlot(unit)) then
			structAttack["Ranged"]=nil;
		else
			--UpdatePaperdollStats(prefix, "PLAYERSTAT_RANGED_COMBAT");
			local damageFrame = getglobal(prefix.."1");
			local damageFrameText = getglobal(prefix.."1".."StatText");

			if(PaperDollFrame.noRanged) then
				structAttack["Ranged"]=nil;
			else
				local rangedAttackSpeed, minDamage, maxDamage, physicalBonusPos, physicalBonusNeg, percent = UnitRangedDamage(unit);

				-- Round to the third decimal place (i.e. 99.9 percent)
				percent = math.floor(percent  * 10^3 + 0.5) / 10^3
				local displayMin = max(floor(minDamage),1);
				local displayMax = max(ceil(maxDamage),1);

				local baseDamage;
				local fullDamage;
				local totalBonus;
				local damagePerSecond;
				local tooltip;

				if ( HasWandEquipped() ) then
					baseDamage = (minDamage + maxDamage) * 0.5;
					fullDamage = baseDamage * percent;
					totalBonus = 0;
					if( rangedAttackSpeed == 0 ) then
						damagePerSecond = 0;
					else
						damagePerSecond = (max(fullDamage,1) / rangedAttackSpeed);
					end
					tooltip = max(floor(minDamage),1).." - "..max(ceil(maxDamage),1);
				else
					minDamage = (minDamage / percent) - physicalBonusPos - physicalBonusNeg;
					maxDamage = (maxDamage / percent) - physicalBonusPos - physicalBonusNeg;

					baseDamage = (minDamage + maxDamage) * 0.5;
					fullDamage = (baseDamage + physicalBonusPos + physicalBonusNeg) * percent;
					totalBonus = (fullDamage - baseDamage);
					if( rangedAttackSpeed == 0 ) then
						damagePerSecond = 0;
					else
						damagePerSecond = (max(fullDamage,1) / rangedAttackSpeed);
						damagePerSecond = math.floor(damagePerSecond  * 10^3 + 0.5) / 10^3
					end
					tooltip = max(floor(minDamage),1).." - "..max(ceil(maxDamage),1);
				end

				local rangedAttackSpeed,minDamage,maxDamage,physicalBonusPos,physicalBonusNeg,percent = UnitRangedDamage(unit);
				structAttack["Ranged"]={};
				structAttack["Ranged"]["AttackSpeed"]=frame.round(rangedAttackSpeed,2);
				structAttack["Ranged"]["AttackDPS"]=frame.round(damagePerSecond,1);
				structAttack["Ranged"]["AttackSkill"]=UnitRangedAttack(unit);

				local rangedAttackBase,rangedAttackMod = UnitRangedAttack(unit);
				structAttack["Ranged"]["AttackRating"]=strjoin(":", rangedAttackBase,rangedAttackMod,0);

				structAttack["Ranged"]["DamageRangeBase"]=strjoin(":", frame.Percent(minDamage),frame.Percent(maxDamage));
				structAttack["Ranged"]["DamageRangeBonus"]=totalBonus;

				base,posBuff,negBuff = GetCombatRating(CR_HIT_RANGED),frame.round(GetCombatRatingBonus(CR_HIT_RANGED),2),0;
				structAttack["Ranged"]["HitRating"]=strjoin(":", base,posBuff,negBuff);
				base,posBuff,negBuff = GetCombatRating(CR_CRIT_RANGED),frame.round(GetCombatRatingBonus(CR_CRIT_RANGED),2),0;
				structAttack["Ranged"]["CritRating"]=strjoin(":", base,posBuff,negBuff);
				base,posBuff,negBuff = GetCombatRating(CR_HASTE_RANGED),frame.round(GetCombatRatingBonus(CR_HASTE_RANGED),2),0;
				structAttack["Ranged"]["HasteRating"]=strjoin(":", base,posBuff,negBuff);
				structAttack["Ranged"]["CritChance"]=frame.round(GetRangedCritChance(),2);

				structAttack["Ranged"]["DamageRangeTooltip"]=tooltip;
				local base,posBuff,negBuff=UnitRangedAttackPower(unit);
				apDPS=base/ATTACK_POWER_MAGIC_NUMBER;
				structAttack["Ranged"]["AttackPower"] = strjoin(":", base,posBuff,negBuff);
				structAttack["Ranged"]["AttackPowerDPS"]=frame.round(apDPS,1);
				structAttack["Ranged"]["AttackPowerTooltip"]=format(RANGED_ATTACK_POWER_TOOLTIP,apDPS);
				structAttack["Ranged"]["HasWandEquipped"]=false;
			end
		end

		structAttack["Spell"] = {};
		structAttack["Spell"]["BonusHealing"] = GetSpellBonusHealing();

		local holySchool = 2;
		local minCrit = GetSpellCritChance(holySchool);
		structAttack["Spell"]["School"]={};
		structAttack["Spell"]["SchoolCrit"]={};
		for i=holySchool,MAX_SPELL_SCHOOLS do
			bonusDamage = GetSpellBonusDamage(i);
			spellCrit = GetSpellCritChance(i);
			minCrit = min(minCrit,spellCrit);
			structAttack["Spell"]["School"][UnitSchoolName[i]] = bonusDamage;
			structAttack["Spell"]["SchoolCrit"][UnitSchoolName[i]] = frame.round(spellCrit,2);
		end

		structAttack["Spell"]["CritChance"] = frame.round(minCrit,2);
		structAttack["Spell"]["BonusDamage"]=GetSpellBonusDamage(holySchool);
		base,posBuff,negBuff = GetCombatRating(CR_HIT_SPELL),frame.round(GetCombatRatingBonus(CR_HIT_SPELL),2),0;
		structAttack["Spell"]["HitRating"]=strjoin(":", base,posBuff,negBuff);
		base,posBuff,negBuff = GetCombatRating(CR_CRIT_SPELL),frame.round(GetCombatRatingBonus(CR_CRIT_SPELL),2),0;
		structAttack["Spell"]["CritRating"]=strjoin(":", base,posBuff,negBuff);
		base,posBuff,negBuff = GetCombatRating(CR_HASTE_SPELL),frame.round(GetCombatRatingBonus(CR_HASTE_SPELL),2),0;
		structAttack["Spell"]["HasteRating"]=strjoin(":", base,posBuff,negBuff);
		structAttack["Spell"]["Penetration"] = GetSpellPenetration();

		local base,casting = GetManaRegen();
		base = floor( (base * 5.0) + 0.5);
		casting = floor( (casting * 5.0) + 0.5);
		structAttack["Spell"]["ManaRegen"] = strjoin(":", base,casting);
	end
	PaperDollFrame_UpdateStats();
end

function frame.Percent(percent)
	percent = math.floor(percent  * 10^3 + 0.5) / 10^3
	return percent;
end

function frame:GetAttackRatingOld(structAttack,unit,prefix)
	if(not unit) then unit="pet"; end
	if(not prefix) then prefix="Pet"; end

	PaperDollFrame_SetDamage(PetDamageFrame, "Pet");
	PaperDollFrame_SetArmor(PetArmorFrame, "Pet");
	PaperDollFrame_SetAttackPower(PetAttackPowerFrame, "Pet");

	local damageFrame = getglobal(prefix.."DamageFrame");
	local damageText = getglobal(prefix.."DamageFrameStatText");
	local mainHandAttackBase,mainHandAttackMod = UnitAttackBothHands(unit);

	structAttack["Melee"]={};
	structAttack["Melee"]["MainHand"]={};
	structAttack["Melee"]["MainHand"]["AttackSpeed"]=frame.round(damageFrame.attackSpeed,2);
	structAttack["Melee"]["MainHand"]["AttackDPS"]=frame.round(damageFrame.dps,1);
	structAttack["Melee"]["MainHand"]["AttackRating"]=mainHandAttackBase+mainHandAttackMod;

	local tt=damageText:GetText();
	tt=frame.StripColor(tt);
	structAttack["Melee"]["MainHand"]["DamageRange"]=string.gsub(tt,"^(%d+)%s?-%s?(%d+)$","%1:%2");

	self:CharacterDamageFrame();
	local tt=frame.scantooltip2();
	tt=frame.StripColor(tt);
	structAttack["Melee"]["DamageRangeTooltip"]=tt;
	local base,posBuff,negBuff = UnitAttackPower(unit);
	apDPS=max((base+posBuff+negBuff),0)/ATTACK_POWER_MAGIC_NUMBER;
	structAttack["Melee"]["AttackPower"] = strjoin(":", base,posBuff,negBuff);
	structAttack["Melee"]["AttackPowerDPS"]=frame.round(apDPS,1);
	structAttack["Melee"]["AttackPowerTooltip"]=format(MELEE_ATTACK_POWER_TOOLTIP,apDPS);
end

--[GetBuffs]
function frame:GetBuffs(structBuffs,unit)
	unit = unit or "player";
	local idx=1;
	if(not structBuffs["Attributes"]) then structBuffs["Attributes"]={}; end
	local function strNil(str)
		if(str and str=="") then return nil
		else return str
		end
	end
	local function numNil(num)
		if(num and num<=1) then return nil
		else return num
		end
	end
	if(UnitBuff(unit,idx)) then
		structBuffs["Attributes"]["Buffs"]={};
		while(UnitBuff(unit,idx)) do
			local name,rank,iconTexture,count,duration,timeLeft = UnitBuff(unit,idx);
			
			GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE')  
			GameTooltip:SetUnitBuff(unit,idx);
			tooltip = frame.scantooltip2()
			GameTooltip:Hide()
			structBuffs["Attributes"]["Buffs"][idx]={
				Name	= name,
				Rank	= strNil(rank),
				Count	= numNil(count),
				Icon	= frame.scanIcon(iconTexture),
				Tooltip	= tooltip};
			idx=idx+1
		end
	else
		structBuffs["Attributes"]["Buffs"]=nil;
	end
	idx=1;
	if(UnitDebuff(unit,idx)) then
		structBuffs["Attributes"]["Debuffs"]={};
		while(UnitDebuff(unit,idx)) do
			local name,rank,iconTexture,count,debuffType,duration,timeLeft = UnitDebuff(unit,idx);
			frame.tooltip:SetUnitDebuff(unit,idx);
			structBuffs["Attributes"]["Debuffs"][idx]={
				Name	= name,
				Rank	= strNil(rank),
				Count	= numNil(count),
				Icon	= frame.scanIcon(iconTexture),
				Tooltip	= frame.scantooltip2()};
			idx=idx+1
		end
	else
		structBuffs["Attributes"]["Debuffs"]=nil;
	end
end

function frame:ScanItemInfo(itemstr,itemtexture,itemcount,slot,bagid)
	local function numNil(num)
		if(wowrpref["fixquantity"] and num and num<=1) then
			return nil
		else
			return num
		end
	end
	if(itemstr) then
		local itemColor,itemLink,itemID,itemName,itemTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity=frame.GetItemInfo(itemstr);
		if(not itemName or not itemColor) then
			itemName,itemColor=frame.GetItemInfoTT(self.tooltip);
		end
		slotx=nil;
		if(bagid=="player") then
			GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE'); 
			GameTooltip:SetInventoryItem("player",slot);
			slotx = slot;
			tooltip = frame.scantooltip2();
			GameTooltip:Hide();
			link = GetInventoryItemLink("player",slot);
		elseif(bagid==BANK_CONTAINER) then
			GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');  
			GameTooltip:SetInventoryItem("player",BankButtonIDToInvSlotID(slot));--SetBagItem(bagid,slot);
			slotx = BankButtonIDToInvSlotID(slot);
			tooltip = frame.scantooltip2();
			GameTooltip:Hide();
			link = itemLink;
		elseif(bagid==KEYRING_CONTAINER) then
			GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');  
			GameTooltip:SetInventoryItem("player",KeyRingButtonIDToInvSlotID(slot));
			slotx = KeyRingButtonIDToInvSlotID(slot);
			tooltip = frame.scantooltip2();
			GameTooltip:Hide();
			link = itemLink;
		else
			GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');  
			slotx = slot;
			GameTooltip:SetBagItem(bagid,slot);
			tooltip = frame.scantooltip2();
			GameTooltip:Hide();
			link = itemLink;
		end

		local itemBlock={
			Name	= itemName,
			Item	= itemID,
			Link	= link,
			Color	= frame.scanColor(itemColor),
			Rarity	= itemRarity,
			Quantity= numNil(itemcount),
			Icon	= frame.scanIcon(itemtexture or itemTexture),
			Tooltip	= tooltip,
			Type	= itemType,
			SubType	= itemSubType,
			iLevel	= itemLevel,
			reqLevel= itemReqLevel,
		};

		if( frame.ItemHasGem(itemID) ) then
			--frame:Print("gem scan "..slot.."-"..slotx.."");
			local gem1, gem2, gem3 = GetInventoryItemGems(slotx);
			local _,_,_,_,gid1,gid2,gid3,_,_,_=string.find(itemID,"([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+)");
			itemBlock["Gem"] = {};

			if (gid1 ~= '0') then
				local itemColor,itemLink,itemID,itemName,itemTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity=frame.GetItemInfo(gem1);

				if (itemLink)then
					GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');
					GameTooltip:SetHyperlink(itemLink);
					tooltip = frame.scantooltip2();
					GameTooltip:Hide();
				else
					tooltip = nil;
				end
				itemBlock["Gem"][1]={ --frame:ScanItemInfo(gemItemLink,nil,1,nil,nil);
					Name = itemName,
					Item = gem1,
					gemID = gid1,
					Color = frame.scanColor(itemColor),
					Link = itemLink,
					Tooltip = tooltip,
					Icon = frame.scanIcon(itemTexture),
				};
			end

			if (gid2 ~= '0') then
				local itemColor,itemLink,itemID,itemName,itemTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity=frame.GetItemInfo(gem2);
				if (itemLink)then
				GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');
				GameTooltip:SetHyperlink(itemLink);
				tooltip = frame.scantooltip2();
				GameTooltip:Hide();
				else
					tooltip = nil;
				end
				itemBlock["Gem"][2]={ --frame:ScanItemInfo(gemItemLink,nil,1,nil,nil);
					Name = itemName,
					Item = gem2,
					gemID = gid2,
					Color = frame.scanColor(itemColor),
					Link = itemLink,
					Tooltip = tooltip,
					Icon = frame.scanIcon(itemTexture),
				};
			end

			if (gid3 ~= '0') then

				local itemColor,itemLink,itemID,itemName,itemTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity=frame.GetItemInfo(gem3);					
				if (itemLink)then
				GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE');
				GameTooltip:SetHyperlink(itemLink);
				tooltip = frame.scantooltip2();
				GameTooltip:Hide();
				else
					tooltip = nil;
				end
				itemBlock["Gem"][3]={ --frame:ScanItemInfo(gemItemLink,nil,1,nil,nil);
					Name = itemName,
					Item = gem3,
					gemID = gid3,
					Color = frame.scanColor(itemColor),
					Link = itemLink,
					Tooltip = tooltip,
					Icon = frame.scanIcon(itemTexture),
				};
			end
		end
		return itemBlock;
	end
	return nil;
end

--[ItemHasGem] itemStr
frame.ItemHasGem = function(itemStr)

	if(itemStr) then 
		local _,_,_,_,gid1,gid2,gid3,_,_,_=string.find(itemStr,"([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+)");

		if( gid1 and gid2 and gid3 and gid1+gid2+gid3 ~= 0) then
			return true;
		else
			return nil;
		end
	end
	return nil;
end

--[[ item functions ]]-- 
frame.UnitHasResSickness = function(unit)
	local idx=1;
	if(UnitDebuff(unit,idx)) then
		while(UnitDebuff(unit,idx)) do
			buffTexture=UnitDebuff(unit,idx);
			if(buffTexture == "Interface\\Icons\\Spell_Shadow_DeathScream") then
				return true;
			end
			idx=idx+1;
		end
	end
	return nil;
end
--[GetItemInfo] itemStr
frame.GetItemInfo = function(itemStr)
	if(itemStr) then
		local itemColor,itemID;
		local itemName,itemLink,itemRarity,itemLevel,itemReqLevel,itemType,itemSubType,itemStackCount,itemEquipLoc,invTexture = GetItemInfo(itemStr);
		if(itemLink) then
			_,_,itemColor,itemID=string.find(itemLink,"|c(%x+)|Hitem:([-%d:]+)|h%[.-%]|h");
		end
		return itemColor,itemLink,itemID,itemName,invTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity;
	end
	return nil;
end

--[GetItemInfoTT] tooltip
frame.GetItemInfoTT = function(tooltip)
	local ttName,ttFrame
	if( tooltip ) then
		if(type(tooltip)=="string") then
			ttName=tooltip;
			ttFrame=getglobal(tooltip);
		elseif(type(tooltip)=="table" and tooltip:IsObjectType("GameTooltip")) then
			ttName=UIParent.GetName(tooltip);
			ttFrame=tooltip;
		end
	end
	local nTT,cTT,r,g,b;
	if(ttName==nil) then return end

	ttText=getglobal(ttName.."TextLeft1");

	if(ttText) then
		nTT=ttText:GetText();
	end
	if(nTT) then
		r,g,b=ttText:GetTextColor();
		cTT=string.format("ff%02x%02x%02x",r*256,g*256,b*256);
	end
	return nTT,cTT;
end

frame.GetContainerNumSlots = function(bagID)
	if(bagID==KEYRING_CONTAINER) then
		return GetKeyRingSize();
	else
		return GetContainerNumSlots(bagID);
	end
end

frame.scantooltip2 = function()
	local ttName = "GameTooltip";
	local isHTML = true

	if(GameTooltip and GameTooltip:NumLines() > 0) then
		local idx,ttFontStr,tmpbuff,ttText=nil,nil,nil,{};
		for idx=1,GameTooltip:NumLines() do
			tmpbuff=nil;
			ttFontStr=getglobal(ttName.."TextLeft"..idx);
			if(ttFontStr and ttFontStr:IsShown()) then
				tmpbuff=ttFontStr:GetText();
				if (ttFontStr) then
					tmpbuff=string.gsub(tmpbuff,"\n","<br>");
					tmpbuff=string.gsub(tmpbuff,"\r","");
				end
			end
			ttFontStr=getglobal(ttName.."TextRight"..idx);
			if(ttFontStr and ttFontStr:IsShown() and ttFontStr:GetText()) then
				if(tmpbuff) then
					tmpbuff=tmpbuff.."\t"..ttFontStr:GetText();
				else
					tmpbuff=ttFontStr:GetText();
				end
			end
			if(tmpbuff) then table.insert(ttText,tmpbuff); end
		end
		GameTooltip:ClearLines();
		if(isHTML) then
			return table.concat(ttText,"<br>");
		else
			return ttText;
		end
	end
	return "";
end

frame.GetReagentId = function(itemStr)
	if(itemStr) then 
		local _,_,itemid,_,_,_,_,_,_,_=string.find(itemStr,"([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+):([-%d]+)");
		if( itemid ~= 0) then
			--frame:Print("has gem "..gid1.." "..gid2.." "..gid3.."");
			return itemid;
		else
			return nil;
		end
	end
	return nil;
end

frame.GetRecipeId = function(recipeStr)
	local id;
	if(recipeStr) then _,_,id = string.find(recipeStr, "|Henchant:(%d+)|h"); end
	return tonumber(id);
end

frame.GetItemID = function(itemStr)
	local id,rid;
	if(itemStr) then _,_,id,rid=string.find(itemStr,"|Hitem:(%d+):[-%d]+:[-%d]+:[-%d]+:[-%d]+:[-%d]+:([-%d]+):[-%d]+:[%d]+|h"); end
	return tonumber(id),tonumber(rid);
end

frame.scanIcon = function(str)
	if(not str) then return nil; end
	str=string.gsub(str,".BLP","");
	return table.remove({ strsplit("\\", str) });
end

frame.parseMoney = function(money)
	local gold,silver,copper;
	local COPPER_PER_GOLD=COPPER_PER_SILVER * SILVER_PER_GOLD;
	gold=floor(money/COPPER_PER_GOLD);
		money=mod(money,COPPER_PER_GOLD);
	silver=floor(money/COPPER_PER_SILVER);
		copper=mod(money,COPPER_PER_SILVER);
	return gold,silver,copper;
end

--[frame.round](num,[digit])
frame.round = function(num,digit)
	if(not tonumber(num)) then return nil; end
	if(digit==nil) then digit=0; end
--	local shift=10^digit;
--	return floor( num*shift + 0.5 ) / shift;
	if(num==0) then return num; end
	local fmt
	if(digit<10) then fmt="%.0"..digit.."f";
	else fmt="%."..digit.."f"; end
	return format(fmt,num);
end

--[Str2Ary] str
frame.Str2Ary = function(str)
	local tab={};
	if(not str ) then return end
	str = strtrim(str);
	while( str and str ~="" ) do
		local word,string;
		if( strfind(str, '^|c.+|r') ) then
			_,_,word,string = strfind( str, '^(|c.+|r)(.*)');
		elseif( strfind(str, '^"[^"]+"') ) then
			_,_,word,string = strfind( str, '^"([^"]+)"(.*)');
		else
			_,_,word,string = strfind( str, '^(%S+)(.*)');
		end
		if( word ) then
			table.insert(tab,word);
		end
		if( string ) then
			string=strtrim(string);
		end
		str = string;
	end
	return tab;
end

--[Str2Abbr] str
frame.Str2Abbr = function(str)
	local abbr='';
	local function S2Ahelper(word) abbr=abbr..string.sub(word,1,1) end
	if not string.find(string.gsub(str,"%w+",S2Ahelper),"%S") then return abbr end
end

--[Arg2Tab] arg:key.1,key.n,val.1,val.n
frame.Arg2Tab = function(...)
	local tab={};
	local split=floor( select("#",...) /2);
	for i=1,split do tab[select(i,...)]=select(i+split,...); end
	return tab;
end

--[Arg2Ary] arg:arg.1,arg.n
frame.Arg2Ary = function(...)
	local tab={};
	for i=1,select("#",...) do tab[i]=select(i,...); end
	return tab; 
end

frame.StringColorize = function(color,msg)
	if(color and msg) then
		return "|cff"..color..msg.."|r";
	end
end

--[function] str
frame.version = function()
	local version,_,_ = GetBuildInfo();
	local _,_,version,major,minor=string.find(version,"(%d+).(%d+).(%d+)");
	return tonumber(version),tonumber(major),tonumber(minor);
end

--[GetQuestID] questStr
frame.GetQuestID = function(questStr)
	local id,lvl;
	if(questStr) then _,_,id,lvl=string.find(questStr,"|Hquest:(%d+):([-%d]+)|h"); end
	return tonumber(id);
end

frame.versionkey = function()
	local version,buildnum,_ = GetBuildInfo();
	return strjoin(":", frame.GetSystem(),version,buildnum);
end

--[function] str
frame.GetSystem = function()
	local _,_,sys=string.find(GetCVar("realmList"),"^[%a.]-(%a+).%a+.%a+.%a+$");
	if(not sys) then sys="" end return sys;
end

function frame:Print(...)
	print("|cff33ff99WoWR Profiler|r:", ...)
end

frame.scanColor = function(str)
	if(not str) then return nil; end
	local _,_,c = string.find(str,"%x%x(%x%x%x%x%x%x)");
	return c
end

--[[
			Begin guild functions....
]]--


function frame:GPUpdateDate()
	if(not WoWRCP.db) then return; end;

	if ( not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["timestamp"] ) then 
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["timestamp"]={};
	end;

	struct=WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["timestamp"];
	local timestamp = time();
	local currHour,currMinute=GetGameTime();
	--struct["timestamp"]={};
	struct["init"]={};
	struct["init"]["TimeStamp"]=timestamp;
	struct["init"]["Date"]=date("%Y-%m-%d %H:%M:%S",timestamp);
	struct["init"]["DateUTC"]=date("!%Y-%m-%d %H:%M:%S",timestamp);
	struct["init"]["ServerTime"]=format("%02d:%02d",currHour,currMinute);
	struct["init"]["datakey"]=frame.versionkey();
	
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["timestamp"] = struct;
end


function frame:GPGetGuildInfo()
	if( not IsInGuild() ) then
		stat["_guilded"]=false;
		return;
	end
	strict = {};
	Guild_name = GetGuildInfo("player");
	local numGuildMembers, onlineMembers = GetNumGuildMembers();

	QueryGuildEventLog();
	local currentXP, remainingXP = UnitGetGuildXP("player");
	local nextLevelXP = currentXP + remainingXP;
	
	stat["_guilded"]=true;
	strict["Info"] = GetGuildInfoText();
	strict["FactionEn"],strict["Faction"] = UnitFactionGroup("player");
	strict["GPversion"]		= "1.2.0";
	strict["CPprovider"]	= "wowr";
	strict["DBversion"]		= "3.1";
	strict["GuildName"]		= xstat["_guild"];
	strict["Server"]		= xstat["_server"];
	strict["Locale"]		= GetLocale();
	strict["GuildXP"]		= currentXP..":"..nextLevelXP;
	strict["GuildLevel"]	= GetGuildLevel();
	strict["Motd"] 			= GetGuildRosterMOTD();
	
	if(numGuildMembers~=0) then
		strict["NumMembers"]=numGuildMembers;
		frame:GPScanGuildMembers(numGuildMembers);
		stat["_guildNum"]=numGuildMembers;
	end
	frame:GPScanGuildMOTD();
	strict["ScanInfo"] = {
		Character = xstat["_player"],
		IsGuildLeader = (IsGuildLeader()==1 or false),
		HasOfficerNote = (stat["_officer"]==1 or false)
	};
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]] = strict;
end
function frame:GPScanGuildMOTD()
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]] = GetGuildRosterMOTD();
end

function frame:GPScanGuildMembers(numMembers)
	xstat["_officer"] = CanViewOfficerNote();
	if ( not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Members"] ) then WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Members"]={}; end;

	local numMembers, onlineMembers = GetNumGuildMembers();
	local showOfflineTemp=GetGuildRosterShowOffline();
	SetGuildRosterShowOffline(true);
	local cnt = 0;
	local guildMemberTemp={};
	for idx=1,numMembers do
		local name,rank,rankIndex,level,class,zone,note,officernote,online,status,classEn,achievementPoints,achievementRank,isMobile=GetGuildRosterInfo(idx);
		local lastonline;
		if(name~=nil)then
			if(xstat["_officer"]) then
			elseif((guildMemberTemp) and guildMemberTemp[name]) then
				officernote = guildMemberTemp[name]["OfficerNote"];
			end

			-- ################### now hardcode but can be used rankindex and setup in options!
			if (rank=="Alter" or rank=="Alter de Ofi") then
				local correct = string.find(note,"ALT-");
				local main = string.sub(note, 5);
				if (correct == nil) then
					--frame:Print(string.format(L["Note: Revise public note for %s (%s) = '%s' should start with 'ALT-'."],name,rank,note));
				elseif ( not UnitIsInMyGuild(main)) then
					--frame:Print(string.format(L["Note: Revise public note for %s (%s) = '%s' because %s is not in the guild."],name,rank,note,main));
				end
			end
			-- ##################

			if(not wowrpref["guild"]["title"]) then rank = nil; end

			if(wowrpref["guild"]["compact"]) then
				if(status=="") then status = nil; end
				if(note=="") then note = nil; end
				if(officernote=="") then officernote = nil; end
			end
			if(not online) then
				lastonline = strjoin(":",GetGuildRosterLastOnline(idx));
			end
			
			guildMemberTemp[name] = {
				Name	= name,
				Rank	= rankIndex,
				RankEn	= rank,
				Title	= rank,
				Level	= level,
				Class	= class,
				ClassId	= frame.UnitClassID(classEn),
				Zone	  = zone,
				Status	= status,
				Note	  = note,
				OfficerNote= officernote,
				Online	   = online,
				LastOnline = lastonline,
				AchPoints = achievementPoints,
				AchRank = achievementRank,
				Mobile = isMobile,
			};

			local weeklyXP, totalXP, weeklyRank, totalRank = GetGuildRosterContribution(idx);
			if weeklyXP then
				guildMemberTemp[name]["XP"] = {};
				guildMemberTemp[name]["XP"] = {
					WeeklyXP = weeklyXP,
					TotalXP = totalXP,
					WeeklyRank = weeklyRank,
					TotalRank = totalRank,
				};
			end
			cnt=cnt+1;
		end
	end

	SetGuildRosterShowOffline(showOfflineTemp);
	if(numMembers==tablelength(guildMemberTemp)) then
		xstat["_guildNum"] = cnt;
		if(xstat["_guildInfo"]~=numMembers) then
			GuildInfo();
			xstat["_guildInfo"]=numMembers;
		end
		--WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Members"]=guildMemberTemp;
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Members"]=guildMemberTemp;
	end
end

function frame:GPScanGuildControl()
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Control"]={};

	for idx=1,GuildControlGetRankFlagsNum(GuildControlGetRankFlags()) do
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Control"][idx]=getglobal("GUILDCONTROL_OPTION"..idx);
	end
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Ranks"]={};
	for idx=1,GuildControlGetNumRanks() do
		GuildControlSetRank(idx);
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Ranks"][idx-1]={
			Title=GuildControlGetRankName(idx),
			Control=self:GuildControlGetRankFlagsStr(GuildControlGetRankFlags()),
			--Withdraw= GetGuildBankTabPermissions(currentTab) (),
		};
		local numTabs = GetNumGuildBankTabs();
		for i=1, MAX_GUILDBANK_TABS do
			if ( i <= numTabs ) then
				local viewTab, canDeposit, updatetext, numWithdrawals = GetGuildBankTabPermissions(i);
				viewTab = viewTab or 0;
				canDeposit = canDeposit or 0;
				numWithdrawals = numWithdrawals or 0;
				WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Ranks"][idx-1]["Tab"..i]=strjoin(":",viewTab, canDeposit, numWithdrawals);
			else
				WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Ranks"][idx-1]["Tab"..i]=nil;
			end
		end
	end
end

function GuildControlGetRankFlagsNum(...)
	return select("#",...);
end

function frame:GPGUILDBANKBAGSLOTS_CHANGED()
	stat["Vaultavl"] = false;
	frame:GPScanGuildBank();
end

function frame.ScanGuildBankQueue()
	local queue = frame.queue;
	if(not queue or table.getn(queue) == 0) then return end;
	for idx,tab in pairs( queue ) do
		if( tab[1] == "GUILDBANKBAGSLOTS_CHANGED" ) then
			QueryGuildBankTab(tab[3]);
		elseif( tab[1] == "GUILDBANKLOG_UPDATE" ) then
			QueryGuildBankLog(tab[3]);
		end
	end
end

function frame:GUILDBANKFRAME_OPENED()
	if(not wowrpref["guild"]["vault"]) then
		return nil;
	end
	numTabs = GetNumGuildBankTabs();
		for tab=1, numTabs do
			QueryGuildBankTab(tab);
		end
	
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]={};
	end
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]={};
	end
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]={};
	end
	xstat["Vault"] = {};
	numTabs = GetNumGuildBankTabs()
	local isViewable
	for tab=1, numTabs do
		if ( xstat["Vaultavl"]) then
			QueryGuildBankTab(tab);
		end
		_,_,isViewable = GetGuildBankTabInfo(tab);

		if( isViewable ) then
			xstat["Vault"]["Tab"..tab]={};
			frame.ScanGuildBankTab(tab);
		else
			WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]=nil;
			WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Tab"..tab]=nil;
		end
	end
	if(wowrpref["guild"]["vault_money"]) then
		frame:GPScanGuildBankMoney()
	end
	frame:Print("Guild vault scaned");
end

function frame.ScanGuildBankTab(tab)
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]={};
	end
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]["Contents"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab]["Contents"]={};
	end

	local gbank = WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab];
	local tabName,tabIcon  = GetGuildBankTabInfo(tab);

	gbank["Name"] = tabName;
	gbank["Icon"] = frame.scanIcon(tabIcon);
	local itemLink;
	local itemIcon, itemCount;
	local bagInv = 0;
	for idx=1, MAX_GUILDBANK_SLOTS_PER_TAB do
		itemIcon, itemCount,_ = GetGuildBankItemInfo(tab,idx);
		itemLink = GetGuildBankItemLink(tab,idx)
		if(itemLink) then
			bagInv=bagInv+1;
		end
		gbank["Contents"][idx] = frame:ScanItemInfo(itemLink,itemIcon,itemCount,idx,tab);
	end
	
	if(wowrpref["guild"]["vault_log"]) then
		frame.ScanGuildBankTabLog(tab)
	end
	local numTransactions = GetNumGuildBankTransactions(tab);

	--WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Tabs"]["Tab"..tab] = gbank;
	--frame:Print("Tab "..tab.." items "..bagInv.." log entrys "..numTransactions.."");
	xstat["Vault"]["Tab"..tab]={slot=MAX_GUILDBANK_SLOTS_PER_TAB,inv=bagInv};
end

function frame:GPScanItemInfo(itemstr,itemtexture,itemcount,idx,tab)
	local function numNil(num)
		if(wowrpref["fixquantity"] and num and num<=1) then return nil
		else return num
		end
	end
	if(itemstr) then
		local itemColor,itemLink,itemID,itemName,itemTexture,itemType,itemSubType,itemLevel,itemReqLevel,itemRarity=frame.GetItemInfo(itemstr);
		if(not itemName or not itemColor) then
			itemName,itemColor=frame.GetItemInfoTT(self.tooltip);
		end

		GameTooltip:SetOwner(UIParent, 'ANCHOR_NONE'); 
		GameTooltip:SetGuildBankItem(tab,idx);
		tooltip = frame.scantooltip2();
		GameTooltip:Hide();
		local itemBlock={
			Name	= itemName,
			Item	= itemID,
			Color	= frame.scanColor(itemColor),
			Rarity	= itemRarity,
			Quantity= numNil(itemcount),
			Icon	= frame.scanIcon(itemtexture or itemTexture),
			Tooltip	= tooltip,
			Type	= itemType,
			SubType	= itemSubType,
			iLevel	= itemLevel,
			reqLevel= itemReqLevel,
		};
		return itemBlock;
	end

	return nil;
end

function frame.ScanGuildBankTabLog(tab)
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Tab"..tab]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Tab"..tab]={};
	end

	local gbankb = WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Tab"..tab];
	local type, name, itemLink, count, tab1, tab2, year, month, day, hour;
	local itemID
	local numTransactions = GetNumGuildBankTransactions(tab);

	if(numTransactions >= table.getn(gbankb)) then
		for idx=1, numTransactions, 1 do
			type, name, itemLink, count, tab1, tab2, year, month, day, hour = GetGuildBankTransaction(tab,idx);
			_,_,itemID=frame.GetItemInfo(itemLink);
			gbankb[idx] = {
				Type	= type,
				Name	= name or UNKNOWN,
				Tab1	= tab1,
				Tab2	= tab2,
				Item	= itemID,
				Count	= count,
				Time	= strjoin(":",year, month, day, hour)
			};
		end
	else
		QueryGuildBankLog(tab);
	end
end

function frame:GPScanGuildBankMoney()
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]={};
	end
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Money"] = frame.Arg2Tab("Gold","Silver","Copper",frame.parseMoney(GetGuildBankMoney()));
	QueryGuildBankLog(MAX_GUILDBANK_TABS+1);
	
	if(wowrpref["guild"]["vault_log"]) then
		frame.ScanGuildBankMoneyLog()
	end
end

function frame.ScanGuildBankMoneyLog()
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]={};
	end
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]={};
	end
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Money"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Money"]={};
	end
	local gbankdb = WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["Vault"]["Log"]["Money"];
	local type, name, amount, year, month, day, hour;
	local numTransactions = GetNumGuildBankMoneyTransactions();

	if(numTransactions >= table.getn(gbankdb)) then
		for idx=1, numTransactions, 1 do
			type, name, amount, year, month, day, hour = GetGuildBankMoneyTransaction(idx);
			gbankdb[idx] = {
				Type	= type,
				Name	= name or UNKNOWN,
				Amount	= amount,
				Time	= strjoin(":",year, month, day, hour)
			};
		end
	end
end

function frame:GPScanGuildEventLog()
	if(not WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["EventLog"]) then
		WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["EventLog"]={};
	end
	local db = WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["EventLog"];
	local type, player1, player2, rank, year, month, day, hour;
	local numEvents = GetNumGuildEvents();
	local time=time();

--RPGOGP:PrintDebug("EventLog",numEvents,table.getn(db));
	if(numEvents >= table.getn(db)) then
		for idx=1, numEvents, 1 do
			type, player1, player2, rank, year, month, day, hour = GetGuildEventInfo(idx);
			if ( not player1 ) then
				player1 = UNKNOWN;
			end
			if ( not player2 ) then
				player2 = UNKNOWN;
			end
			db[idx] = {
				Type	= type,
				Player1	= player1,
				Player2	= player2,
				Rank	= rank,
				Time	= time,
				LogTime	= strjoin(":",year, month, day, hour),
			};
		end
	else
		QueryGuildEventLog();
	end
	WoWRCP.db[xstat["_server"]]["Guild"][xstat["_guild"]]["EventLog"] = db;
end

function  frame:GuildControlGetRankFlagsStr(...)
	local flags={};
	for i=1,select("#",...) do
		local v=select(i,...);
		v = v or 0;
		table.insert(flags,v);
	end
	return(table.concat(flags,":"));
end

function tablelength(T)
	local count = 0
	for _ in pairs(T) do
		count = count + 1
	end
	return count
end 










